      subroutine adapt
      include 'declare.h'
      parameter(maxn=100)
      parameter(maxv=100)
      double precision wei(maxn,maxv),alfa(maxn,maxv),alfao(maxn,maxv)
     .,beta(0:maxn,maxv),low(maxn,maxv),upp(maxn,maxv)
      double precision lo(maxv),up(maxv)
      double precision lo1,up1
      integer ich(maxv)
      integer init(maxv)
      integer nch(maxv)
      integer kount0(maxv)
      integer kount1(maxv)
      data init/maxv*0/
      save

c parameters
c nch lo up kount0

      entry adapt_gen(nchi,lo1,up1,x,iv)

c     print*,'nch(iv)i,lo1,up1,x,iv'
c     print*, nch(iv)i,lo1,up1,iv
      nch(iv)=nchi
      lo(iv)=lo1
      up(iv)=up1

      if(init(iv).eq.0)then
c[1
      kount_g=0
      kount_p=0

      wei(1:maxn,1:maxv)=0
      maxadap=10000
      iadap=0
      kount0(iv)=1500 !50*nch(iv)
      kount1(iv)=1500 !50*nch(iv)
      ex=0.05
      ey=1d0

      beta(0,iv)=0
      do i=1,nch(iv)
       alfa(i,iv)=1d0/nch(iv)     
       beta(i,iv)=beta(i-1,iv)+alfa(i,iv)
       low(i,iv)=lo(iv)+(up(iv)-lo(iv))/nch(iv)*(i-1)
       upp(i,iv)=lo(iv)+(up(iv)-lo(iv))/nch(iv)*i
      enddo
      init(iv)=1
c]1  
      endif

      r=rnmy(0)
      do i=1,nch(iv)
       if(r.lt.beta(i,iv))goto 1
      enddo
 1    ich(iv)=i

      r=rnmy(0)
      x=(1-r)*low(ich(iv),iv)+r*upp(ich(iv),iv) 
      if(iv.eq.1)kount_g=kount_g+1


      return

      entry adapt_weo(wo,iv)
      
      wo=(upp(ich(iv),iv)-low(ich(iv),iv))/alfa(ich(iv),iv)
c     print*,'IV',iv,ich(iv),wo

      return

      entry adapt_wei(w,iv,niv)
      wei(ich(iv),iv)=wei(ich(iv),iv)+w  !*w/alfa(ich)
      if(iv.eq.1.and.w.gt.0)then
       kount_p=kount_p+1
c      if(mod(kount_p,100).eq.1)print*,kount_p
      endif


       kcrit=max(kount_p,1)

c      kcrit=max(kount_g,1)

      if(w.gt.0.and.iadap.lt.maxadap.and.mod(kcrit,kount0(iv)).eq.0)then
c[3
       alfao(1:nch(iv),iv)=alfa(1:nch(iv),iv)
       if(iv.eq.1)iadap=iadap+1
c     if(iv.eq.niv)then
        kount1(iv)=kount1(iv)*1.2
        kount0(iv)=kount0(iv)+kount1(iv)
c       if(iadap.eq.5)call clear(0)
c       if(iadap.le.5.and.iv.eq.niv)call clear(1)
c     endif


       do i=1,nch(iv)
c       alfa(i,iv)= alfa(i,iv)**(1-ex) * wei(i,iv)**ex
        alfa(i,iv)= alfa(i,iv)**ey * wei(i,iv)**ex
       enddo

       alfamin=alfa(1,iv)
c      do i=1,nch(iv)
c       if(alfa(i,iv).gt.0.and.alfa(i,iv).lt.alfamin)alfamin=alfa(i,iv)
c       if(alfa(i,iv).lt.1d-1/nch(iv))alfa(i,iv)=1d-1/nch(iv)
c      enddo

       tota=0
       do i=1,nch(iv)
c       if(alfa(i,iv).eq.0)alfa(i,iv)=alfamin*0.5
        tota=tota+alfa(i,iv)
       enddo
     

       do i=1,nch(iv)
        alfa(i,iv)=alfa(i,iv)/tota
        beta(i,iv)=beta(i-1,iv)+alfa(i,iv)
       enddo

       ave=0
       avem=0
       do i=1,nch(iv)
        da=0
        if(alfao(i,iv).gt.0)
     +  da=dabs(alfa(i,iv)-alfao(i,iv))/alfao(i,iv)
        ave=ave+da/nch(iv)
        avem=max(avem,da)
       enddo
       print*,'ADAPT.F params: ',iv,ave,avem,iadap,kount0(iv)
c       print'(d12.6)',alfa(1:nch(iv),iv)

c      if(avem.lt.0.2d0.and.iadap.gt.5)iadap=maxadap+1
c      wei(1:nch(iv))=0
c]3
      endif

      return
      end
