       include 'declare.h'
       
       include 'common_int.h'
       include 'common_masses.h'
       include 'common_flags.h'
       include 'common_feyn.h'
       include 'common_new.h'
       include 'common_print.h'

       character*24, histo,error
 
       character*2 char(20)
       character*100 process
       
       call zmset(34)

       nunit1=6
     
       print*,'histo file'
       read*,histo,error
       print*,'histo file',histo,error
       print*,'repeat,ranhel'
       read*,repeat,iranhel
       print*,'repeat',repeat,'  ranhel',iranhel
       print*,'Number of particles'
       read*,n
       print*,n
       print*,'Flavour of particles'
       read*,(ifl(i),i=1,n)
       print*,(ifl(i),i=1,n)
       print*,'iflag,iunitary,ihiggs,iwidth'
       read*,iflag,iunitary,ihiggs,iwidth
       print*,iflag,iunitary,ihiggs,iwidth
       
       call physics

       do i=1,n
       if(i.le.2)then
        io(i)=1
       else
        io(i)=-1
       endif
       enddo

       do i=1,n
        if(ifl(i).eq. 2)char(i)='E-'
        if(ifl(i).eq.-2)char(i)='E+'
        if(ifl(i).eq. 1)char(i)='Ne'
        if(ifl(i).eq.-1)char(i)='N1'
        if(ifl(i).eq. 3)char(i)='Uq'
        if(ifl(i).eq.-3)char(i)='Ua'
        if(ifl(i).eq. 4)char(i)='Dq'
        if(ifl(i).eq.-4)char(i)='Da'
        if(ifl(i).eq. 6)char(i)='M-'
        if(ifl(i).eq.-6)char(i)='M+'
        if(ifl(i).eq. 5)char(i)='Nm'
        if(ifl(i).eq.-5)char(i)='N2'
        if(ifl(i).eq. 7)char(i)='Cq'
        if(ifl(i).eq.-7)char(i)='Ca'
        if(ifl(i).eq. 8)char(i)='Sq'
        if(ifl(i).eq.-8)char(i)='Sa'
        if(ifl(i).eq. 10)char(i)='T-'
        if(ifl(i).eq.-10)char(i)='T+'
        if(ifl(i).eq. 9)char(i)='Nt'
        if(ifl(i).eq.-9)char(i)='N3'
        if(ifl(i).eq. 11)char(i)='Tq'
        if(ifl(i).eq.-11)char(i)='Ta'
        if(ifl(i).eq. 12)char(i)='Bq'
        if(ifl(i).eq.-12)char(i)='Ba'
        if(ifl(i).eq.31)char(i)='A0'
        if(ifl(i).eq.32)char(i)='Z0'
        if(ifl(i).eq.33)char(i)='W+'
        if(ifl(i).eq.34)char(i)='W-'
        if(ifl(i).eq.35)char(i)='G0'
       enddo
       write(process,*)(char(i),i=1,n)
       print*,process(2:2*n+1)

c      open(6,  file='out_'//process(2:2*n+1)//'.out')
c      nunit1=6
c      open(nunit1,file='proc_'//process(2:2*n+1)//'.out')
       nunit2=112
       open(nunit2,file='kine_'//process(2:2*n+1)//'.out')
       nunit3=110
       open(nunit3,file='even_'//process(2:2*n+1)//'.out'
     . ,form='unformatted')

       if(repeat.eq.0)call helac_init
       if(repeat.eq.1) then
c       open(20,file='cmat_'//process(2:2*n+1)//'.in')
        open(21,file='tree_'//process(2:2*n+1)//'.in')
c       open(22,file='kine_'//process(2:2*n+1)//'.in')
c       open(20,file='cmat.in')
c       open(21,file='tree.in')
c       open(22,file='kine.in')
        call helac_init
        close(0)
        stop
       endif
       if(repeat.eq.2)then
c       open(20,file='cmat_'//process(2:2*n+1)//'.in')
        open(21,file='tree_'//process(2:2*n+1)//'.in')
c       open(22,file='kine_'//process(2:2*n+1)//'.in')
c       open(20,file='cmat.in')
c       open(21,file='tree.in')
c       open(22,file='kine.in')
        call getlist
        read(21,*)ng
        do i1=1,ng
        do j1=1,8
        read(21,*)(is(i1,j1,k1),k1=1,8)
        enddo
        enddo
       endif

c some initialization for histograms       
       nh=0
        open(16,file=histo)
        open(17,file=error)
       write(16,*)ifl(3),ifl(4),ifl(5),ifl(6),ifl(7)
       call histo3(nh)
c ---------

c ---------
c THE MAIN INTEGRATION ROUTINE: see below       
c ---------
       call integration(w0)


       
c ---------
c output histograms
       do i=1,nh
        call histo2(i,0,w0)
       enddo
c ---------
       


       stop
       end
      

       subroutine integration(w0)
       include 'declare.h'

       include 'common_int.h'
       include 'common_mom.h'
       include 'common_masses.h'
       include 'common_feyn.h'
       include 'common_phegas_mom.h'
       include 'common_new.h'
       include 'common_print.h'
       include 'common_norm.h'
       include 'common_strf.h'
       include 'common_warn.h'

       dimension alpha(ng+1),beta(0:ng+1),wei(ng+1),wpsp(ng+1)
     .           ,p(20,4),igraph(ng+1)
     .           ,icount0(0:ng+1),icount1(0:ng+1)
     .           ,wmax(10),alpha_m(ng+1),x(ng+1),y(ng+1)
 
       dimension ig_m(ng+1)
       
       real*8 hlower,hupper,hvaria,hweigh

       character*3 file
       
c WRITE OUT
c START
       logical lunwei
c lunwei: for unweightinga   !1/3
       data lunwei/.false./  !2/3
c      data lunwei/.true./   !3/3
       logical lwmax,lwri
       data lwmax/.false./
       integer nwri,nwmax,nwarn
       data nwri/0/,nwmax/0/,nwarn/0/
       double precision umax,umax1
       data umax/0/
c END

       data init/0/
       save init
       

       icount0(0:ng+1)=0
       icount1(0:ng+1)=0
      
       print*,'NG=',ng
       if(ng.eq.0)then
        print*,'no FG contributions found: BYE'
        stop
       endif
c --------------------------------------------------------------
c         START OF INITIALIZATION
c---------------------------------------------------------------
       if(init.eq.0)then

	beta(0)=0
	igraph(1:ng+1)=0
	inonzero=0
        read*,ncha
        print*,'option for kinematical channels:',ncha
	if(ncha.eq.0)then
         nch=ng+1
         do i=1,nch
          igraph(i)=mod(i,ng+1)
         enddo
        elseif(ncha.eq.1)then
         nch=1
         igraph(1)=0
        elseif(ncha.eq.-1)then
         read*,nch
         do i=1,nch
          igraph(i)=i
         enddo
        endif
        print*,'Number of channels',nch
        print*,'Number of MC points'
        read*,nmc
        print*,' nmc  = ',nmc
        alpha(1:nch)=dnou(1)/nch
        alpha_m(1:nch)=alpha(1:nch)
	do i=1,nch
	 beta(i)=beta(i-1)+alpha(i)
	enddo
        read*,nopti,nopt_step,optf,maxopt,noptlim,iopt
        nopt=100
        number_opt=0
        wmax(1:10)=0
        wmemax=0
        wme=1
        if(nch.eq.1)then
         iopt=0
         maxopt=-1
        endif
        print*,'nopt,nopt_step,optf,maxopt,iopt'
        print*, nopt,nopt_step,optf,maxopt,iopt
        print*,'number of channels=',nch
       
        init=1
       endif
c --------------------------------------------------------------
c         END  OF INITIALIZATION
c---------------------------------------------------------------
       

 4     continue

       ipass=0
       do iev=1,nmc

       w=0
       wme=0
       wei(1:nch)=0

       call igen(nch,beta(1:nch),ig)


       icount0(igraph(ig))=icount0(igraph(ig))+1
       
       call phegas(wpsp(ig),igraph(ig),0,iweight)
cx     call test_gen(wpsp(ig),igraph(ig),0,iweight)
       if(iweight.eq.0)goto2
       if(iweight.eq.-1)goto1
       
       if(wpsp(ig).le.0)then
c       print*,'wpsp1=',ig,wpsp(ig)
        goto1
       endif
      
cx
       call cuts(icut)
       if(icut.eq.0)goto1
cdef include cuts from possible decays
c      call decays(0,icut,w)
c      if(icut.eq.0)goto1
 
       wpsp_t=0

       do i=1,nch
        
        if(i.ne.ig)then
        
         call phegas(wpsp(i),igraph(i),1,iweight)
cx       call test_gen(wpsp(i),igraph(i),1,iweight)
         if(iweight.eq.0)goto2
         if(iweight.eq.-1)goto1
        
         if(wpsp(i).gt.0)then
          wpsp_t=wpsp_t+alpha(i)/wpsp(i)
         else 
 	  print*,'wpsp2=',wpsp(i),i,wpsp(ig),ig
 	 endif
       
        else
       
         wpsp_t=wpsp_t+alpha(i)/wpsp(i)
       
        endif
       
       enddo

       inonzero=inonzero+1
       icount1(igraph(ig))=icount1(igraph(ig))+1

       wpsp_t=wpsp_t**(-1)

       if(istruc.eq.1)call physics
       call helac_master(wme)
       print*,wme
       call mad(wme1)
       print*,wme1,wme1/wme
cx     wrest=1
cx     call test_func(wme)

       w=wpsp_t*wme*wrest
c      print*,'iev,w,wme,wpsp_t'
c      print*, iev,w,wme,wpsp_t


       wsf=1
       if(istruc.eq.1)call strf(wsf)
       w=w*wsf

       ipass=ipass+1

cdef include cuts just for histograms
c      call decays(1,icut,w)


      if(number_opt.le.maxopt)then
       wei(1:nch)=0
       do i=1,nch
        if(wpsp(i).gt.0) wei(i)=w*w*wpsp_t/wpsp(i)
       enddo
      endif

       if(wme.gt.wmemax)then
        wmemax=wme
c       print*,'me',wmemax,ig
       endif
       if(w.gt.wmax(1))then
        do i=10,2,-1
         wmax(i)=wmax(i-1)
        enddo
        if(wmax(1).gt.0)then
         if(w/wmax(1).gt.10)then
          write(nunit2,*)'WARNING ABOUT WEIGHT'
          ii=igraph(ig)
          write(nunit2,*)iev,igraph(ig),alpha(ig)
          write(nunit2,*)w,wme,wpsp_t
          if(ii.gt.0)then
           k=1
           do while(is(ii,k,1).ne.0)
            write(nunit2,*)is(ii,k,1:8)
            k=k+1
           enddo
          endif
          write(nunit2,*)w,wmax
          write(nunit2,*)(i,pmom(i,1:4),i=1,n)
          write(nunit2,*)'--------------------'
         endif
        endif
        wmax(1)=w
       endif

c WRITE OUT EVENTS
c START
c --------------
      if(lunwei)then
c --------------
      if(.not.lwmax.and.
     .(number_opt.gt.maxopt.or.iopt.eq.0))then
       if(umax.lt.w)then
        umax=w
        print*,'umax=',umax
       endif
       nwmax=nwmax+1
       umax1=umax
      endif
      if(nwmax.eq.2*nopt_step) then
       nwmax=nwmax+1
       lwmax=.true.
       write(nunit1,*)'START UNWEIGHTING',iev
      endif
      if(lwmax)then
      if(w.gt.umax1)then
       umax1=w
       write(nunit1,*)'iev,umax1',iev,umax1
      endif
      lwri=.false.
      if(umax*rnmy(0).lt.w)lwri=.true.
      if(umax.lt.w)nwarn=nwarn+1
      if(lwri)then
      nwri=nwri+1
      write(nunit3)pmom(3,1:4),pmom(4,1:4),pmom(5,1:4)
     .,pmom(6,1:4),pmom(7,1:4),pmom(8,1:4),w
c     do i=1,4
c     print*,i,
c    .pmom(3,i)+pmom(4,i)+pmom(5,i)+pmom(6,i)+pmom(7,i)+pmom(8,i)
c     enddo
      endif
      endif
c     rewind(nunit3)
c     read(nunit3)pmom(3,1:4),pmom(4,1:4),pmom(5,1:4)
c    .,pmom(6,1:4),pmom(7,1:4),pmom(8,1:4),w
c     print*,pmom(3:8,4),w
c --------------
      endif
c --------------
c END

 1     continue   
       
       call bookin(1,w)
       call bookin(2,wme)
       if(number_opt.le.maxopt)then
       do i=1,nch
        call bookin(i+2,wei(i))
       enddo
       endif 
       
 
 2     continue   
        
       call geti(1,0,w0)
       
c      print*,'w0=',w0

       if(mod(iev,500).eq.0)then
        call errest(1,x1,y1,0)
	print'(a6,2d15.6,3i10)','sigma=',x1,sqrt(y1),inonzero,int(w0),iev
	write(17,*)iev,x1,sqrt(y1)
        print*,'----------------------------'
       endif
       
       if(iev.eq.nopt)then
        if(ipass.eq.0)nopt=nopt*2
       endif
       if(iev.eq.nopt.and.iopt.eq.1
     . .and.number_opt.le.maxopt.and.nch.gt.1)then

        sum=0
	do i=1,nch 
	 call errest(i+2,x(i),y(i),0)
         sum=sum+alpha(i)*x(i)
c        x(i)=x(i)+2*dsqrt(y(i))
        enddo
        write(1000,*)number_opt+1,sum
        
c print*,nch,igraph(1:ng)
	nch0=nch

	call optimize(nch,igraph(1:nch),alpha,nm,ig_m,alpha_m,x,iend)
       
        if(iend.eq.2)number_opt=maxopt

        if(number_opt.ge.1)then
         data iunit/100/
         write(nunit1,*)'UNIT=',iunit
         write(file,'(i3)') iunit
         open(iunit,file='data.'//file)
         write(iunit,'(i4)')nch
         do i=1,nch
         write(iunit,'(3(e10.4,5x),i8)')
     .   alpha(i),x(i),dsqrt(y(i)),igraph(i)
         enddo
         close(iunit)
         iunit=iunit+1
        endif

        if(number_opt.eq.0)then
         nopt=nopti
        else
         nopt=nopt+nopt_step
        endif

      write(nunit1,*)'----------------------------'
      write(nunit1,*)'iev,nopt,number_opt,maxopt,nch,nch0'
     .            , iev,nopt,number_opt,maxopt,nch,nch0

c       print*,'<w>/w_max,x1,wmax',x1/wmax(1),x1,wmax
	
        if(nopt.gt.noptlim)number_opt=maxopt
	nopt_step=nopt_step*optf
        number_opt=number_opt+1

	if(number_opt.gt.maxopt)then
         nch=nm
         igraph(1:nch)=ig_m(1:nch)
	 do i=1,nch
	  alpha(i)=alpha_m(i)
          if(10*alpha(i).gt.1)then
           k=1
           ii=igraph(i)
           write(nunit1,*)'the graph',ii,alpha(i)
           if(ii.eq.0)cycle
           do while(is(ii,k,1).ne.0)
            write(nunit1,*)is(ii,k,1:8)
            k=k+1
           enddo
          endif
	 enddo
         open(iunit,file='data.final')
         write(iunit,'(i4)')nch
         do i=1,nch
         write(iunit,'(e10.4,i8)')alpha(i),igraph(i)
         enddo
         close(iunit)
         iunit=iunit+1
	endif

         wmax(1:10)=0
	 do i=1,nch
	  beta(i)=beta(i-1)+alpha(i)
	 enddo

c        print*,'----------------------------'
c        print*,nch,beta(nch)
c        eps1= 0 !dnou(1)/100
c        do l=1,nch
c        if(alpha(l).gt.eps1)
c    .	 print'(i4,2d16.8)',igraph(l),alpha(l),beta(l) 
c        enddo
c        print*,'----------------------------'

         if(number_opt.eq.1.or.number_opt.gt.maxopt)then
         write(nunit1,*)'clear ',number_opt,' opt'
         do l=1,nch0
          call clear(l+2)
         enddo
         inonzero=0
         call clear(1)
         call clear(2)
         goto4
         endif

 3      continue       
       endif
       
       
       enddo
   
c      do i=1,nch 
c       call errest(i+2,x(i),y(i),0)
c       print*,'channel',nch,i,igraph(i),x(i),dsqrt(y(i))
c      enddo

       print*,'out of ',nmc,'  ',int(w0),' points have been used'
       print*,'and  ',inonzero,' points resulted to =/= 0 weight'
       print*,'whereas  ',int(w0)-inonzero,' points to 0 weight'
       call errest(1,x1,y1,1)
       if(x1.gt.0)print*,'% error:',dsqrt(y1)/x1*100
       write(16,*)x1,sqrt(y1)
       if(wmax(1).gt.0)
     . print*,'<w>/w_max,w_max',x1/wmax(1),wmax(1)
       call errest(2,x1,y1,0)
       if(wmemax.gt.0)
     . print*,'<me>/memax,memax',x1/wmemax,wmemax
     
       do j=1,25
        if(iwarning(j).gt.0)print*,'iwarning(',j,') = ',iwarning(j)
        if(iwonders(j).gt.0)print*,'iwonders(',j,') = ',iwonders(j)
       enddo
       print*,'number of w=1 events',nwri
       print*,'number of w>1 events',nwarn
       print*,'maximum weight used for un:vs',umax,umax1

cx
cx     call test_end

       return
       end
      
     
       subroutine optimize(n,igraph,a,nm,ig_m,am,x,iend)
       include 'declare.h'

       include 'common_feyn.h'
       dimension a(n),am(n),x(n),igraph(n),ig_m(*)
       data init/0/,ex/.25d0/,alimit/0/
       data icount/0/
       save d,ex,alimit,nlim

       if(init.eq.0)then
                     if(n.le.100)nlim=10
        if(n.gt.100.and.n.le.200)nlim=20
        if(n.gt.200.and.n.le.500)nlim=40
                     if(n.gt.500)nlim=60
        d=0
        xmax=0
        iend=0
        read*,alimit
        if(alimit.gt.0)alimit=dnou(1)/n/10
        print*,'LIMIT=',alimit,nlim
        print*,'DUMPFAC=',ex
        goto13
        return
       endif
     
c      if(alimit.gt.0)alimit=min(dnou(1)/n/10,dnou(1)/nlim/10)
       if(alimit.gt.0)alimit=dnou(1)/n/10
       print*,'LIMIT=',alimit

c      w_mean=0
c      do i=1,n
c       w_mean=w_mean+a(i)*x(i)
c      enddo
c      xmax=0
c      do i=1,n
c       if(xmax.lt.abs(w_mean-x(i)))xmax=abs(w_mean-x(i))
c      enddo
c      if(xmax/w_mean.gt.d)return
c      d=xmax/w_mean
c      do i=1,n-1
c       do j=i+1,n
c        if(xmax.lt.abs(x(i)-x(j)))xmax=abs(x(i)-x(j))
c       enddo
c      enddo

       a1=0
       do i=1,n
	a1=a1+a(i)*x(i)**ex
       enddo

       xmax=0
       do i=1,n
        if(i.eq.1)then
         xmax=abs(a1-x(1)**ex)
        else
         xmax=max(xmax,abs(a1-x(i)**ex))
        endif
       enddo
        
       if(init.eq.1)then
        d=xmax
        init=2
       endif
       
       print*,'This opt. max=',xmax,n

       if(xmax.le.d)then
c       d=xmax
c      endif
        ig_m(1:n)=igraph(1:n)
        nm=n
	am(1:n)=a(1:n)
        d=xmax
c       iend=max(iend-1,0)
       else
c       iend=iend+1
       endif

       print*,'All opt.    d=',d
       icount=icount+1
       write(1001,*)icount,xmax

 13    continue
       do i=1,n
        a(i)=a(i)*x(i)**ex
       enddo
       
       n1=n
 11    continue
       call normalize(a(1:n1),n1)

       if(alimit.eq.0.and.init.gt.0)return

       if(init.gt.0)then
        j=n1
        do k=1,n1
         if(a(k).lt.alimit)j=j-1
        enddo
        if(j.le.nlim)return
       endif
  
       
       k=0
       j=0
       istop=0
       do while(istop.eq.0)
        k=k+1
        j=j+1
c       if(j.eq.n1-1)istop=1
        if(j.eq.n1)istop=1

	if(init.eq.0)then
c check for equal gen.
        eps1=dnou(1)/dnou(10)**11
	do l=1,n1
         ratio=abs(a(k)-a(l))/(a(k)+a(l))
         if(k.ne.l.and.ratio.lt.eps1.and.a(k).gt.0)then
ccosats
          data ix/0/
          ix=ix+1
          print*,igraph(k),a(k)
          print*,igraph(l),a(l)
          print*,is(igraph(k),1,1:9)
          print*,is(igraph(k),2,1:9)
          print*,is(igraph(l),1,1:9)
          print*,is(igraph(l),2,1:9)
          print*,ix,'----------------------------------'
ccostas
          igraph(k:n1-1)=igraph(k+1:n1)
          igraph(n1)=0
          a(k:n1-1)=a(k+1:n1)
          a(n1)=0
          k=k-1
	  goto 12
         endif
	enddo
	endif

c check for negligible gen.
        if(a(k).lt.alimit.and.init.gt.0)then
         igraph(k:n1-1)=igraph(k+1:n1)
         igraph(n1)=0
         a(k:n1-1)=a(k+1:n1)
         a(n1)=0
         k=k-1
        endif

 12     continue
        enddo

ck=k+1
cif(a(k).lt.alimit) k=k-1
   

       if(k.lt.n1)then
        n1=k
        call normalize(a(1:n1),n1)
c       goto11
       endif
       
       if(n1.le.n.and.init.eq.0)then
	d=0
	init=1
        do k=1,n1
         a(k)=dnou(1)/n1
        enddo
       endif
       n=n1
       
       return
       end

       subroutine igen(n,b,ig)
       include 'declare.h'

       dimension b(1:n)

       r=rnmy(0)
       do i=1,n
       ig=i
       if(r-b(i).lt.0)return
       enddo 

       end
      
       subroutine normalize(a,n)
       include 'declare.h'
       dimension a(n)
       
       atot=0
       do i=1,n
        atot=atot+a(i)
       enddo
       do i=1,n
        a(i)=a(i)/atot
       enddo
       
       return
       end

       subroutine transform(n,zq,p)
       include 'declare.h'
       dimension zq(n,4),p(n,4)

        do i=1,n 
         p(i,4)=dreal(zq(i,1)+zq(i,2))/2
         p(i,3)=dreal(zq(i,1)-zq(i,2))/2
         p(i,1)=dreal(zq(i,3))
         p(i,2)=dimag(zq(i,3))
        enddo

        return
        end

       subroutine strf(wsf)
       include 'declare.h'
       
       include 'common_int.h'
       include 'common_strf.h'
       include 'parameter_pp.h'          

       character*20 parm(20)
       double precision val(20)
      
       save init
       data init/0/

       call structm(xp1,scale,uv1,dv1,us1,ds1,st1,ch1,bo1,to1,gl1)
       call structm(xp2,scale,uv2,dv2,us2,ds2,st2,ch2,bo2,to2,gl2)

       sf=1
      
       if(ipp.eq.1)then
        if(ifl(1).eq.3)  sf=sf*uv1
        if(ifl(1).eq.-3) sf=sf*us1
        if(ifl(1).eq.4)  sf=sf*dv1
        if(ifl(1).eq.-4) sf=sf*ds1
        if(ifl(1).eq.7)  sf=sf*ch1
        if(ifl(1).eq.-7) sf=sf*ch1
        if(ifl(1).eq.8)  sf=sf*st1
        if(ifl(1).eq.-8) sf=sf*st1
        if(ifl(1).eq.11) sf=sf*to1
        if(ifl(1).eq.-11)sf=sf*to1
        if(ifl(1).eq.12) sf=sf*bo1
        if(ifl(1).eq.-12)sf=sf*bo1
        if(ifl(1).eq.35) sf=sf*gl1

        if(ifl(2).eq.3)  sf=sf*uv2
        if(ifl(2).eq.-3) sf=sf*us2
        if(ifl(2).eq.4)  sf=sf*dv2
        if(ifl(2).eq.-4) sf=sf*ds2
        if(ifl(2).eq.7)  sf=sf*ch2
        if(ifl(2).eq.-7) sf=sf*ch2
        if(ifl(2).eq.8)  sf=sf*st2
        if(ifl(2).eq.-8) sf=sf*st2
        if(ifl(2).eq.11) sf=sf*to2
        if(ifl(2).eq.-11)sf=sf*to2
        if(ifl(2).eq.12) sf=sf*bo2
        if(ifl(2).eq.-12)sf=sf*bo2
        if(ifl(2).eq.35) sf=sf*gl2
       elseif(ipp.eq.2)then
        if(ifl(1).eq.3)  sf=sf*uv1
        if(ifl(1).eq.-3) sf=sf*us1
        if(ifl(1).eq.4)  sf=sf*dv1
        if(ifl(1).eq.-4) sf=sf*ds1
        if(ifl(1).eq.7)  sf=sf*ch1
        if(ifl(1).eq.-7) sf=sf*ch1
        if(ifl(1).eq.8)  sf=sf*st1
        if(ifl(1).eq.-8) sf=sf*st1
        if(ifl(1).eq.11) sf=sf*to1
        if(ifl(1).eq.-11)sf=sf*to1
        if(ifl(1).eq.12) sf=sf*bo1
        if(ifl(1).eq.-12)sf=sf*bo1
        if(ifl(1).eq.35) sf=sf*gl1

        if(ifl(2).eq.3)  sf=sf*us2
        if(ifl(2).eq.-3) sf=sf*uv2
        if(ifl(2).eq.4)  sf=sf*ds2
        if(ifl(2).eq.-4) sf=sf*dv2
        if(ifl(2).eq.7)  sf=sf*ch2
        if(ifl(2).eq.-7) sf=sf*ch2
        if(ifl(2).eq.8)  sf=sf*st2
        if(ifl(2).eq.-8) sf=sf*st2
        if(ifl(2).eq.11) sf=sf*to2
        if(ifl(2).eq.-11)sf=sf*to2
        if(ifl(2).eq.12) sf=sf*bo2
        if(ifl(2).eq.-12)sf=sf*bo2
        if(ifl(2).eq.35) sf=sf*gl2
       endif

c      if(ifl(1).eq. 3.and.ifl(2).eq.-3.or.
c    &    ifl(1).eq.-3.and.ifl(2).eq. 3)then
c      if(init.eq.0)print*,'qq',ifl(1),ifl(2)
c      sf =uv1*us2+us1*uv2+dv1*ds2+ds1*dv2
c    &        +2.d0*(us1*us2+ds1*ds2)            !q+q or qb+qb
c    &        +2.d0*(st1*st2+ch1*ch2+bo1*bo2)
c      endif
c      if(ifl(1).eq.35.and.ifl(2).eq.35)then 
c      if(init.eq.0)print*,'gg',ifl(1),ifl(2)
c      sf =gl1*gl2                           !g+g
c      endif                             

       wsf=wjac*sf/xp1/xp2
       if(init.eq.0)init=1
       
       return
       end
     
       include 'pdfset.h'
