       subroutine pan(nc1) 
       include 'declare.h'
c      include 'parameter.h'
       include 'nguess.h'
       include 'common_print.h'
       
       integer ih(:,:),ih1(:,:),icole(:,:),ipp(:,:,:),jxx(:),
     .         kcou(:),list(:,:,:),list_tmp(:,:,:),list1(:,:),ico(:,:)
       integer ife(:,:)
       allocatable ih,ih1,icole,ipp,jxx,kcou,list,list1,ico,list_tmp
       allocatable ife
       save ih,ih1,icole,ipp,jxx,kcou,list,list1
       save ife,iv1,iv2
      
       logical log1,log2,log3,log4

       integer an(-12:44)
       save an

       save zero,zi
       save init_pi
        
c      save kcount,icc,ncc,kmax,imax,igluon
       save kcount,icc,kmax,imax,igluon
       
       dimension zy(:,:)
       allocatable zy
       save zy
       save pi
       dimension z0(4),z1(4),z2(4),z3(4)
       dimension zq1(5)
       dimension zp0(4),zp1(4),zp2(4)
     
       include 'common_int.h'
       include 'common_mom.h'
       include 'common_masses.h'
       include 'common_helc.h'
       include 'common_coup.h'
       include 'common_new.h'
       
       call mypi(pi)
       zero=dcmplx(dnou(0),dnou(0))
       zi=dcmplx(dnou(0),dnou(1))
       
       data an/12,11,10,9,8,7,6,5,4,3,2,1,0,
     .         -1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,
     .         13,14,15,16,17,18,19,20,
     .         21,22,23,24,25,26,27,28,29,30,
     .         31,32,34,33,35,36,37,38,39,40,41,42,44,43/
     
       ncc=nc1
       write(nunit1,*)'ncc,ngues',ncc,ngues

       allocate( ih(2**n-2,-12:44),
     .           ih1(2**n-2,-12:44),
     .           icole(2**n-2,2),
     .           ipp(0:2**n-2,-12:44,3),
     .           kcou(ncc),
     .           list(ngues,18,ncc),
     .           jxx(ngues),
     .           list1(n,3),
     .           ife(2**n-2,-12:44),
     .           stat=istat)
       
       
       if(istat.ne.0)then
        print*,'warning: allocation is not working properly in pan'
        stop
       endif
       
       icc=1
       iv1=31
       iv2=34
       ife(1:2**n-2,-12:44)=0
       list(1:ngues,1:18,1:ncc)=0
       
       return
       
* ----------------------------------------------------------------------- 
      
       entry pan_ini
       
       if(ncc.gt.1)iv2=35
        
       
       ih(1:2**n-2,-12:44)=0
       ih1(1:2**n-2,-12:44)=0
       ife(1:2**n-3,-12:44)=0
       icole(1:2**n-2,1:2)=0

       
       do k=1,n
        
        ii=2**(k-1)
       
        icole(ii,1)=icol(k,1)
        icole(ii,2)=icol(k,2)
                
        if(io(k).eq.1)ih(ii,ifl(k))=1
        if(io(k).eq.1)ife(ii,ifl(k))=1
        if(io(k).eq.-1)ih(ii,an(ifl(k)))=1
        if(io(k).eq.-1)ife(ii,an(ifl(k)))=1
        
        if(ifl(k).eq.35)then
         if(icol(k,1).eq.icol(k,2))then
          icole(ii,1:2)=0
         endif
        endif
       enddo

        do k=1,n
       
        list1(k,1)=2**(k-1)
        if(io(k).eq.1)list1(k,2)=ifl(k)
        if(io(k).eq.-1)list1(k,2)=an(ifl(k))
        
        if(list1(k,2).eq.31.or.list1(k,2).eq.35)
     .  list1(k,3)=1
        
        if(list1(k,2).ge.32.and.list1(k,2).le.34)list1(k,3)=2
        
        if(list1(k,2).ge.1.and.list1(k,2).le.12)then
         if(io(k).eq.1)list1(k,3)=3
         if(io(k).eq.-1)list1(k,3)=6
        endif
        
        if(list1(k,2).ge.-12.and.list1(k,2).le.-1)then
         if(io(k).eq.1)list1(k,3)=5
         if(io(k).eq.-1)list1(k,3)=4
        endif
        
        if(list1(k,2).ge.41.and.list1(k,2).le.44)list1(k,3)=7
      
c       print*,'the particle number',k,'  with',list1(k,1:3)
        
       enddo
       
       kcount=0
       jxx(1:ngues)=0
 
c        print*,'colour flow of particles',(i,'(',icol(i,1:2),')',i=1,n)       
c        print*,'icol  ==>',icol(1:n,1:2)
c        print*,'icole ==>',icole(1:2**n-2,1:2) 
       return

* -----------------------------------------------------------------------------       
       entry v3(i0,le,m0,i1,i2,i3)
c	  print*,'v3 ==>'


         m3=0
         lpol=0

c         print*,'iv1,iv2',iv1,iv2
         do m1=iv1,iv2
         do m2=iv1,iv2

           if(m1.eq.m2)then
            if(level(n,i1).gt.level(n,i2))cycle
            if(level(n,i1).eq.level(n,i2).and.i1.gt.i2)cycle
           endif
	    
           if(ih(i1,m1).ne.0)then
           if(ih(i2,m2).ne.0)then
           if(zgv3(m0,m1,m2).ne.zero)then
           
c          icole(i0,1:2)=0
          
	   igluon=0              ! once more
	  
	   if(m1.eq.35.and.icc.le.ncc)then

	   if(icole(i1,1)*icole(i1,2)
     .       *icole(i2,1)*icole(i2,2).eq.0)cycle
	   
	   if(icole(i1,1).eq.icole(i2,2))then
	    icole(i0,2)=icole(i1,2)
	    icole(i0,1)=icole(i2,1)
	    igluon=1
	   elseif(icole(i1,2).eq.icole(i2,1))then
	    icole(i0,2)=icole(i2,2)
	    icole(i0,1)=icole(i1,1)
	    igluon=2
	   endif

	   if(igluon.eq.0)cycle 
	   if(icole(i0,1).eq.icole(i0,2))then
            icole(i0,1:2)=0
	    igluon=0
	    cycle
	   endif
	   endif


c           print*,''
c           print*,'v3' 
c           print*,'m1,m2,m0 ===>',m1,m2,m0
c           print*,'i1,i2,i0 ===>',i1,i2,i0,' ===>',le
c           print*,'zgv3(m0,m1,m2)',zgv3(m0,m1,m2)

c           print*,'--1---',i1,m1,icole(i1,1:2)
c           print*,'--2---',i2,m2,icole(i2,1:2)
c           print*,'icole(',i0,',1)',icole(i0,1)
c           print*,'icole(',i0,',2)',icole(i0,2)



c           print*,'v3: m1,m2',m1,m2,le
c           print*,'v3: i1,i2',i1,i2 
c           print*,'i0,m0 w v3',i0,m0
           ih(i0,m0)=1
           irou=4
           include 'list.h' 
  
         endif
         endif
         endif

	   igluon=0              ! once more
       
         enddo
         enddo
c       print*,'icole',icole(1:2**n-2,1:2)   
 
        return

* -----------------------------------------------------------------------------       
        entry v4(i0,le,m0,i1,i2,i3)
c        print*,'v4 ==>'        
         lpol=0
              
c         print*,'iv1,iv2 in v4',iv1,iv2  
         do m1=iv1,iv2
         do m2=iv1,iv2
         do m3=iv1,iv2 
          
           if(m1.eq.m2)then
            if(level(n,i1).gt.level(n,i2))cycle
            if(level(n,i1).eq.level(n,i2).and.i1.gt.i2)cycle
           endif
           if(m1.eq.m3)then
            if(level(n,i1).gt.level(n,i3))cycle
            if(level(n,i1).eq.level(n,i3).and.i1.gt.i3)cycle
           endif
           if(m2.eq.m3)then
            if(level(n,i2).gt.level(n,i3))cycle
            if(level(n,i2).eq.level(n,i3).and.i2.gt.i3)cycle
           endif
          
          if(ih(i1,m1).ne.0)then
          if(ih(i2,m2).ne.0)then
          if(ih(i3,m3).ne.0)then
          if(zgv4(m0,m1,m2,m3).ne.zero)then

	  igluon=0              ! once more
          
	  if(m1.eq.35.and.icc.le.ncc)then
          
          if(icole(i1,1)*icole(i1,2)
     .      *icole(i2,1)*icole(i2,2)
     .      *icole(i3,1)*icole(i3,2).eq.0)cycle
c tutaj          
	   if(icole(i1,1).eq.icole(i2,2).and.
     .        icole(i1,2).eq.icole(i3,1))then
            icole(i0,2)=icole(i3,2)
            icole(i0,1)=icole(i2,1)
            igluon=1
c tutaj
       elseif(icole(i1,1).eq.icole(i3,2).and.
     .        icole(i1,2).eq.icole(i2,1))then
            icole(i0,2)=icole(i2,2)
            icole(i0,1)=icole(i3,1)
            igluon=2
c tutaj
       elseif(icole(i2,1).eq.icole(i1,2).and.
     .        icole(i2,2).eq.icole(i3,1))then
            icole(i0,2)=icole(i3,2)
            icole(i0,1)=icole(i1,1)
            igluon=3
c tutaj
       elseif(icole(i2,1).eq.icole(i3,2).and.
     .        icole(i2,2).eq.icole(i1,1))then
            icole(i0,2)=icole(i1,2)
            icole(i0,1)=icole(i3,1)
            igluon=3
c tutaj
       elseif(icole(i3,1).eq.icole(i1,2).and.
     .        icole(i3,2).eq.icole(i2,1))then
            icole(i0,2)=icole(i2,2)
            icole(i0,1)=icole(i1,1)
            igluon=4
c tutaj
       elseif(icole(i3,1).eq.icole(i2,2).and.
     .        icole(i3,2).eq.icole(i1,1))then
            icole(i0,2)=icole(i1,2)
            icole(i0,1)=icole(i2,1)
            igluon=4
       else
        cycle
       endif
	    
           if(igluon.eq.0)cycle
	   if(icole(i0,1).eq.icole(i0,2))then
            icole(i0,1:2)=0
	    igluon=0
	    cycle
	   endif
          if(icole(i0,1).eq.icole(i0,2))cycle


       endif

c           print*,''
c           print*,'v4' 
c           print*,'m1,m2,m3,m0 ===>',m1,m2,m3,m0
c           print*,'i1,i2,i3,i0 ===>',i1,i2,i3,i0,' ===>',le
c           print*,'zgv4(m0,m1,m2,m3)',zgv4(m0,m1,m2,m3)

c           print*,'--1---',i1,m1,icole(i1,1:2)
c           print*,'--2---',i2,m2,icole(i2,1:2)
c           print*,'--3---',i3,m3,icole(i3,1:2)
c           print*,'icole(',i0,',1)',icole(i0,1)
c           print*,'icole(',i0,',2)',icole(i0,2)


           ih(i0,m0)=1
           irou=5
           include 'list.h'         
          
	  igluon=0              ! once more
        
         endif
         endif
         endif
         endif
         
         enddo
         enddo
         enddo
         
         
         return

* -----------------------------------------------------------------------------       
       entry vvs(i0,le,m0,i1,i2,i3)
c       print*,'vvs ==>'
         m3=0
         lpol=0
         
         do m1=iv1,iv2
         do m2=41,44
           
           if(zgvvs(m0,m1,m2).ne.zero
     .    .and.ih(i1,m1).ne.0
     .    .and.ih(i2,m2).ne.0)then

           ih(i0,m0)=1
           irou=9
           include 'list.h'         


c           print*,''
c           print*,'vvs' 
c           print*,'m1,m2,m0 ===>',m1,m2,m0
c           print*,'i1,i2,i0 ===>',i1,i2,i0,' ===>',le


c           print*,'zgvvs(m0,m1,m2)',zgvvs(m0,m1,m2)

c           print*,'--1---',i1,m1,icole(i1,1:2)
c           print*,'--2---',i2,m2,icole(i2,1:2)
c           print*,'icole(',i0,',1)',icole(i0,1)
c           print*,'icole(',i0,',2)',icole(i0,2)
         
         endif
 
         enddo
         enddo
         
 
        return

* -----------------------------------------------------------------------------       
       entry vss(i0,le,m0,i1,i2,i3)
c       print*,'vss ==>'
       m3=0
       lpol=0
         
         
         do m1=41,44
         do m2=41,44
          
          igo=1
          if(m1.eq.m2.and.i1.gt.i2)igo=-1   !12 
           
           if(zgvss(m0,m1,m2).ne.zero
     .    .and.ih(i1,m1).ne.0
     .    .and.ih(i2,m2).ne.0
     .    .and.igo.eq.1)then
    
           ih(i0,m0)=1
           irou=16
           include 'list.h'         
         

c           print*,''
c           print*,'vss' 
c           print*,'m1,m2,m0 ===>',m1,m2,m0
c           print*,'i1,i2,i0 ===>',i1,i2,i0,' ===>',le


c           print*,'zgvss(m0,m1,m2)',zgvss(m0,m1,m2)

c           print*,'--1---',i1,m1,icole(i1,1:2)
c           print*,'--2---',i2,m2,icole(i2,1:2)
c           print*,'icole(',i0,',1)',icole(i0,1)
c           print*,'icole(',i0,',2)',icole(i0,2)
         
         endif
 
         enddo
         enddo
         
 
        return

* -----------------------------------------------------------------------------       
        entry vff(i0,le,m0,i1,i2,i3)

        m3=0
        lpol=0

c to remove any contribution with a g,Z and W as propagators
c       if(m0.eq.31.and.le.gt.1.and.le.lt.n-1)return
c       if(m0.eq.32.and.le.gt.1.and.le.lt.n-1)return
c       if(m0.eq.33.and.le.gt.1.and.le.lt.n-1)return
c       if(m0.eq.34.and.le.gt.1.and.le.lt.n-1)return
           
           do m1=-12,-1
           do m2=1,12
           
c[ special instructions
        include 'specialinstvff.h'
c] special instructions

       

              if(ih(i1,m1).ne.0.and.
     .           ih(i2,m2).ne.0.and.
     .(zgvffr(m0,m1,m2).ne.zero.or.zgvffl(m0,m1,m2).ne.zero))then


                  
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c   for -12<m<0    icole=(0,x)
c   for   0<m<12   icole=(x,0)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
          
           igluon=0          ! once more

           if(m0.eq.35)then
              if(icole(i1,2).eq.icole(i2,1))then
                 igluon=2
                 if(level(n,i0).eq.n-1)igluon=3
                 icole(i0,1:2)=0
              else
                 igluon=1
                 icole(i0,1)=icole(i2,1)
                 icole(i0,2)=icole(i1,2)
              endif
           else
              if(icole(i1,2).ne.icole(i2,1))cycle
              icole(i0,1:2)=0
           endif

c            print*,''
c           print*,'vff' 
c           print*,'m1,m2,m0 ===>',m1,m2,m0
c           print*,'i1,i2,i0 ===>',i1,i2,i0,' ===>',le
c           print*,'zgvffr(m0,m1,m2)',zgvffr(m0,m1,m2)
c           print*,'zgvffl(m0,m1,m2)',zgvffl(m0,m1,m2)

c           print*,'--1---',i1,m1,icole(i1,1:2)
c           print*,'--2---',i2,m2,icole(i2,1:2)
c           print*,'icole(',i0,',1)',icole(i0,1)
c           print*,'icole(',i0,',2)',icole(i0,2)


           ih(i0,m0)=1
           irou=1
           include 'list.h' 
           
	   endif
          
           igluon=0          ! once more

           enddo
           enddo
           

          
           return

* -----------------------------------------------------------------------------       
        entry ffv(i0,le,m0,i1,i2,i3) 

         m3=0
         
           do m2=1,12
           do m1=iv1,iv2
            
            
        
           if(ih(i1,m1).eq.0.or.ih(i2,m2).eq.0)cycle
           
           if(zgvffr(an(m1),-m0,m2).eq.zero
     .   .and.zgvffl(an(m1),-m0,m2).eq.zero)cycle

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c   for -12<m<0    icole=(0,x)
c   for   0<m<12   icole=(x,0)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c           tutaj
           
           igluon=0            ! once more

           if(m1.eq.35)then
              if(icole(i1,2).eq.icole(i2,1))then
                 igluon=1
                 icole(i0,1)=icole(i1,1)
                 icole(i0,2)=0
              elseif(icole(i1,1).eq.0)then
                 igluon=2
                 if(level(n,i1).eq.1)igluon=3
                 icole(i0,1:2)=icole(i2,1:2)
              else
                 cycle
              endif
           else
              icole(i0,1:2)=icole(i2,1:2)
           endif

c           print*,''
c           print*,'ffv' 
c           print*,'m1,m2,m0 ===>',m1,m2,m0
c           print*,'i1,i2,i0 ===>',i1,i2,i0,' ===>',le
c           print*,'zgvffr(an(m1),-m0,m2)',zgvffr(an(m1),-m0,m2)
c           print*,'zgvffl(an(m1),-m0,m2)',zgvffl(an(m1),-m0,m2)           

c           print*,'--1---',i1,m1,icole(i1,1:2)
c           print*,'--2---',i2,m2,icole(i2,1:2)
c           print*,'icole(',i0,',1)',icole(i0,1)
c           print*,'icole(',i0,',2)',icole(i0,2)
           
           if(zgvffl(an(m1),-m0,m2).ne.zero)then
        
           ih(i0,m0)=1
           irou=3
           lpol=1
           include 'list.h' 
         
           endif
     
           if(zgvffr(an(m1),-m0,m2).ne.zero)then
            
	   ih(i0,m0)=1
           irou=3
           lpol=2
           include 'list.h'         
        
           endif


          
           igluon=0            ! once more
          
 
         enddo
         enddo
         
         

        return
        
* -----------------------------------------------------------------------------       
        entry ffs(i0,le,m0,i1,i2,i3) 
c        print*,'ffs ==>'
         m3=0
        
         
           do m2=1,12
           do m1=41,44
           
           if(ih(i1,m1).eq.0.or.ih(i2,m2).eq.0)cycle
           
           if(zgsffr(an(m1),-m0,m2).eq.zero
     .   .and.zgsffl(an(m1),-m0,m2).eq.zero)cycle
     
	   icole(i0,1:2)=icole(i2,1:2)
 

c           print*,''
c           print*,'ffs' 
c           print*,'m1,m2,m0 ===>',m1,m2,m0
c           print*,'i1,i2,i0 ===>',i1,i2,i0,' ===>',le



c           print*,'zgsffr(an(m1),-m0,m2)',zgsffr(an(m1),-m0,m2)
c           print*,'zgsffl(an(m1),-m0,m2)',zgsffl(an(m1),-m0,m2)

c           print*,'--1---',i1,m1,icole(i1,1:2)
c           print*,'--2---',i2,m2,icole(i2,1:2)
c           print*,'icole(',i0,',1)',icole(i0,1)
c           print*,'icole(',i0,',2)',icole(i0,2) 

           
           if(zgsffl(an(m1),-m0,m2).ne.zero)then
c              print*,'tutaj'
 
           ih(i0,m0)=1
           irou=6
           lpol=1
           include 'list.h'         
        
               
           endif
            
           if(zgsffr(an(m1),-m0,m2).ne.zero)then
            
           ih(i0,m0)=1
           irou=6
           lpol=2
           include 'list.h'         


         
           endif

         enddo
         enddo
         
         
        return
        
* -----------------------------------------------------------------------------
        entry affv(i0,le,m0,i1,i2,i3) 

         m3=0
c         print*,'iv1,iv2',iv1,iv2
          do m2=-12,-1
          do m1=iv1,iv2
           
           if(ih(i1,m1).eq.0.or.ih(i2,m2).eq.0)cycle
           
           if(zgvffr(an(m1),m2,-m0).eq.zero
     .   .and.zgvffl(an(m1),m2,-m0).eq.zero)cycle
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c   for -12<m<0    icole=(0,x)
c   for   0<m<12   icole=(x,0)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

           
           igluon=0            ! once more

           if(m1.eq.35)then
              if(icole(i1,1).eq.icole(i2,2))then
                 igluon=1
                 icole(i0,2)=icole(i1,2)
                 icole(i0,1)=0
              elseif(icole(i1,1).eq.0)then
                 igluon=2
                 if(level(n,i1).eq.1) igluon=3 
                 icole(i0,1:2)=icole(i2,1:2)
              else
                 cycle
              endif
           else
              icole(i0,1:2)=icole(i2,1:2)
           endif

c           print*,''
c           print*,'affv' 
c           print*,'m1,m2,m0 ===>',m1,m2,m0
c           print*,'i1,i2,i0 ===>',i1,i2,i0,' ===>',le
c           print*,'zgvffr(an(m1),m2,-m0)',zgvffr(an(m1),m2,-m0)
c           print*,'zgvffl(an(m1),m2,-m0)',zgvffl(an(m1),m2,-m0)

c           print*,'--1---',i1,m1,icole(i1,1:2)
c           print*,'--2---',i2,m2,icole(i2,1:2)
c           print*,'icole(',i0,',1)',icole(i0,1)
c           print*,'icole(',i0,',2)',icole(i0,2)

           if(zgvffl(an(m1),m2,-m0).ne.zero)then
      
	   ih(i0,m0)=1
           irou=2
           lpol=1
           include 'list.h'
         
      
           endif

               
           if(zgvffr(an(m1),m2,-m0).ne.zero)then
     

    
	   ih(i0,m0)=1
           irou=2
           lpol=2
           include 'list.h'         
          
           endif

c          print*,'--0---',i0,m0,icole(i0,1:2)
           igluon=0            ! once more

      
          enddo
          enddo
     
        
       
       
  
        return

* -----------------------------------------------------------------------------
        entry affs(i0,le,m0,i1,i2,i3) 
c        print*,'affs ==>'
         m3=0
         
          do m2=-12,-1
          do m1=41,44
          
        
            if(ih(i1,m1).ne.0.and.
     .         ih(i2,m2).ne.0.and.
     .         zgsffl(an(m1),m2,-m0).ne.zero)then
          
     
	   icole(i0,1:2)=icole(i2,1:2)
           ih(i0,m0)=1
           irou=7
           lpol=1
           include 'list.h'         

c           print*,''
c           print*,'affs' 
c           print*,'m1,m2,m0 ===>',m1,m2,m0
c           print*,'i1,i2,i0 ===>',i1,i2,i0,' ===>',le


c           print*,'zgsffl(an(m1),m2,-m0)',zgsffl(an(m1),m2,-m0)
c           print*,'zgsffr(an(m1),m2,-m0)',zgsffr(an(m1),m2,-m0)
c           print*,'--1---',i1,m1,icole(i1,1:2)
c           print*,'--2---',i2,m2,icole(i2,1:2)
c           print*,'icole(',i0,',1)',icole(i0,1)
c           print*,'icole(',i0,',2)',icole(i0,2)

     
           endif

      
            if(ih(i1,m1).ne.0.and.
     .         ih(i2,m2).ne.0.and.
     .         zgsffr(an(m1),m2,-m0).ne.zero)then
           
          
	   icole(i0,1:2)=icole(i2,1:2)
           ih(i0,m0)=1
           irou=7
           lpol=2
           include 'list.h'         

       
         endif


          enddo
          enddo
     
  
        return
* -----------------------------------------------------------------------------       

       entry sff(i0,le,m0,i1,i2,i3)
c       print*,'sff ==>'
        m3=0
        lpol=0
         
         do m1=-12,-1
         do m2=1,12
           
           if(
     .     (zgsffr(m0,m1,m2).ne.zero.or.zgsffl(m0,m1,m2).ne.zero)
     .    .and.ih(i1,m1).ne.0
     .    .and.ih(i2,m2).ne.0)then
     
            if(icole(i1,1).ne.icole(i2,2)
     .    . or.icole(i1,2).ne.icole(i2,1))cycle
  

           ih(i0,m0)=1
           irou=8
           include 'list.h'         
           
c           print*,''
c           print*,'sff' 
c           print*,'m1,m2,m0 ===>',m1,m2,m0
c           print*,'i1,i2,i0 ===>',i1,i2,i0,' ===>',le

c           print*,'zgsffr(m0,m1,m2)',zgsffr(m0,m1,m2)
c           print*,'zgsffl(m0,m1,m2)',zgsffl(m0,m1,m2)


c           print*,'--1---',i1,m1,icole(i1,1:2)
c           print*,'--2---',i2,m2,icole(i2,1:2)
c           print*,'icole(',i0,',1)',icole(i0,1)
c           print*,'icole(',i0,',2)',icole(i0,2)


           endif
           
         enddo
          
         enddo
          

        return
* -----------------------------------------------------------------------------       
       entry s3(i0,le,m0,i1,i2,i3)
c       print*,'s3 ==>'
         m3=0
         lpol=0
         
         do m1=41,44
         do m2=41,44
           
           igo=1
           if(m1.eq.m2.and.i1.gt.i2)igo=-1  !12
           
           if(zgs3(m0,m1,m2).ne.zero
     .    .and.ih(i1,m1).ne.0
     .    .and.ih(i2,m2).ne.0
     .    .and.igo.eq.1)then
        
           ih(i0,m0)=1
           irou=13
           include 'list.h'         
          
c           print*,''
c           print*,'s3' 
c           print*,'m1,m2,m0 ===>',m1,m2,m0
c           print*,'i1,i2,i0 ===>',i1,i2,i0,' ===>',le

c           print*,'zgs3(m0,m1,m2)',zgs3(m0,m1,m2)

           endif

 
         enddo
         enddo
         
 
        return


* -----------------------------------------------------------------------------       
        entry s4(i0,le,m0,i1,i2,i3)
c       print*,'s4 ==>'

         lpol=0

         do m1=41,44
         do m2=41,44
         do m3=41,44
          
           igo=1
           if(m1.eq.m2.and.i1.gt.i2)igo=-1  !12
           if(m1.eq.m3.and.i1.gt.i3)igo=-1  !13
           if(m2.eq.m3.and.i2.gt.i3)igo=-1  !23


           
           if(zgs4(m0,m1,m2,m3).ne.zero
     .    .and.ih(i1,m1).ne.0
     .    .and.ih(i2,m2).ne.0
     .    .and.ih(i3,m3).ne.0
     .    .and.igo.eq.1)then
  

           ih(i0,m0)=1
           irou=14
           include 'list.h'         


c           print*,''
c           print*,'s4' 
c           print*,'m1,m2,m3,m0 ===>',m1,m2,m3,m0
c           print*,'i1,i2,i3,i0 ===>',i1,i2,i3,i0,' ===>',le  

c           print*,'zgs4(m0,m1,m2,m3)',zgs4(m0,m1,m2,m3)
         
           endif


       
 
         enddo
         enddo
         enddo
         

        return

* -----------------------------------------------------------------------------       

       entry svv(i0,le,m0,i1,i2,i3)
c       print*,'svv ==>'
         m3=0
         lpol=0
         
         do m1=iv1,iv2
         do m2=iv1,iv2
           
           igo=1
           if(m1.eq.m2.and.i1.gt.i2)igo=-1
           
           if(zgsvv(m0,m1,m2).ne.zero
     .    .and.ih(i1,m1).ne.0
     .    .and.ih(i2,m2).ne.0
     .    .and.igo.eq.1)then
  
          
           ih(i0,m0)=1
           irou=10
           include 'list.h'         
         

c           print*,''
c           print*,'svv' 
c           print*,'m1,m2,m0 ===>',m1,m2,m0
c           print*,'i1,i2,i0 ===>',i1,i2,i0,' ===>',le


c           print*,'zgsvv(m0,m1,m2)',zgsvv(m0,m1,m2)



c           print*,'--1---',i1,m1,icole(i1,1:2)
c           print*,'--2---',i2,m2,icole(i2,1:2)
c           print*,'icole(',i0,',1)',icole(i0,1)
c           print*,'icole(',i0,',2)',icole(i0,2)

          endif
         
 
         enddo
         enddo
         
 
        return

* -----------------------------------------------------------------------------       
       entry ssv(i0,le,m0,i1,i2,i3)
c       print*,'ssv ==>'
         m3=0
         lpol=0
         
         do m1=41,44
         do m2=iv1,iv2
           
          if(
     .     zgssv(m0,m1,m2).ne.zero
     .    .and.ih(i1,m1).ne.0
     .    .and.ih(i2,m2).ne.0)then
   
           ih(i0,m0)=1
           irou=15
           include 'list.h'         
         
c           print*,''
c           print*,'ssv' 
c           print*,'m1,m2,m0 ===>',m1,m2,m0
c           print*,'i1,i2,i0 ===>',i1,i2,i0,' ===>',le

c           print*,'zgssv(m0,m1,m2)',zgssv(m0,m1,m2)



c           print*,'--1---',i1,m1,icole(i1,1:2)
c           print*,'--2---',i2,m2,icole(i2,1:2)
c           print*,'icole(',i0,',1)',icole(i0,1)
c           print*,'icole(',i0,',2)',icole(i0,2)


        endif 
         
 
         enddo
         enddo
         
 
        return

* -----------------------------------------------------------------------------       

       entry vvss(i0,le,m0,i1,i2,i3)
c       print*,'vvss ==>'
         lpol=0

         do m1=iv1,iv2
         do m2=41,44
         do m3=41,44
           
           igo=1
           if(m2.eq.m3.and.i2.gt.i3)igo=-1
           
           if(zgvvss(m0,m1,m2,m3).ne.zero
     .    .and.ih(i1,m1).ne.0
     .    .and.ih(i2,m2).ne.0
     .    .and.ih(i3,m3).ne.0
     .    .and.igo.eq.1)then
          
     
           ih(i0,m0)=1
           irou=11
           include 'list.h'         

c           print*,''
c           print*,'vvss' 
c           print*,'m1,m2,m3,m0 ===>',m1,m2,m3,m0
c           print*,'i1,i2,i3,i0 ===>',i1,i2,i3,i0,' ===>',le

c           print*,'zgvvss(m0,m1,m2,m3)',zgvvss(m0,m1,m2,m3)



c           print*,'--1---',i1,m1,icole(i1,1:2)
c           print*,'--2---',i2,m2,icole(i2,1:2)
c           print*,'--2---',i3,m3,icole(i3,1:2)
c           print*,'icole(',i0,',1)',icole(i0,1)
c           print*,'icole(',i0,',2)',icole(i0,2)

          
         endif
         
         enddo
         enddo
         enddo
       
         
         return
* -----------------------------------------------------------------------------       
      entry ssvv(i0,le,m0,i1,i2,i3)
c      print*,'ssvv ==>'

       lpol=0

         do m1=41,44
         do m2=iv1,iv2
         do m3=iv1,iv2
           
           igo=1
           if(m2.eq.m3.and.i2.gt.i3)igo=-1
          
           if(zgssvv(m0,m1,m2,m3).ne.zero
     .    .and.ih(i1,m1).ne.0
     .    .and.ih(i2,m2).ne.0
     .    .and.ih(i3,m3).ne.0
     .    .and.igo.eq.1)then
          
           ih(i0,m0)=1
           irou=12
           include 'list.h'         


c           print*,''
c           print*,'ssvv' 
c           print*,'m1,m2,m3,m0 ===>',m1,m2,m3,m0
c           print*,'i1,i2,i3,i0 ===>',i1,i2,i3,i0,' ===>',le


c           print*,'zgssvv(m0,m1,m2,m3)',zgssvv(m0,m1,m2,m3)



c           print*,'--1---',i1,m1,icole(i1,1:2)
c           print*,'--2---',i2,m2,icole(i2,1:2)
c           print*,'--3---',i3,m3,icole(i3,1:2)
c           print*,'icole(',i0,',1)',icole(i0,1)
c           print*,'icole(',i0,',2)',icole(i0,2)

          
         endif
         
         enddo
         enddo
         enddo
       
         
         return
* -----------------------------------------------------------------------------       
        entry redo(ic1,ino)
        
        data maxmul/0/,kmax/0/,imax/0/
        
        ino=0

         if(kcount.eq.0)then
         icc=icc+1
         ino=1
cic1=ic1+1
ckcou(ic1)=0
        write(nunit1,'(a7,i6,a24,i8,a15)')
     . 'for the',icc-1,'  colour conf. there are',0,'  subamplitudes'
         return
        endif

        
c       write(nunit1,*)'icc=',icc,kcount
c       write(nunit1,'(19i4)')(k,list(k,1:18,icc),k=1,kcount)

 
        do k=kcount,1,-1
        
        j0=list(k,2,icc)
        n0=list(k,3,icc)
        j1=list(k,7,icc)
        n1=list(k,8,icc)
        j2=list(k,10,icc)
        n2=list(k,11,icc)
        j3=list(k,13,icc)
        n3=list(k,14,icc)

c        print*,'an(ifl(1))',an(ifl(1))
c        stop
        if(j0.eq.2**n-2.and.n0.eq.an(ifl(1)))then

         jxx(k)=1
         ih1(j1,n1)=1
         ih1(j2,n2)=1
         if(j3.ne.0)ih1(j3,n3)=1

        else

         if(ih1(j0,n0).eq.1)then
         jxx(k)=1
         ih1(j1,n1)=1
         ih1(j2,n2)=1
         if(j3.ne.0)ih1(j3,n3)=1
         endif
  
        endif

        enddo 
      
        k1=0

        ic1=ic1+1

        do k=1,kcount
           
        if(jxx(k).eq.1)then
         k1=k1+1
         
         list(k1,1:18,ic1)=list(k,1:18,icc)
c	 print'(11i4)',k1,list(k1,1:18,ic1)
c        write(10,*)list(k1,1:10,ic1)
       
        endif
       
        enddo

        kcou(ic1)=k1

        if(ic1.eq.ncc)then
         kk=0
         do jj=1,ncc
          kk=kk+kcou(jj)
         enddo
         if(kk.eq.0)then
         print*,'there are no contributions to this process'
         stop
        endif
        endif
        
        icc=icc+1
        if(k1.eq.0)then
         ic1=ic1-1
         ino=1
         write(nunit1,'(a7,i6,a24,i8,a15)')
     .  'for the',icc-1,'  colour conf. there are',k1,'  subamplitudes'
         return
        endif
        
        ii1=0
        mm1=0
        ip=n
        
        ipp(0:2**n-2,-12:44,1:3)=0
        
        do i=1,n
         ipp(list1(i,1),list1(i,2),1)=i
        enddo

        inofeyn=0
        
        do k=1,k1
        
        is=0
        is1=0
        if(k.gt.1)then
          if(list(k,2,ic1).eq.list(k-1,2,ic1))is=is+1
          if(list(k,3,ic1).eq.list(k-1,3,ic1))is=is+1     
          if(list(k,7,ic1).eq.list(k-1,7,ic1))is=is+1     
          if(list(k,8,ic1).eq.list(k-1,8,ic1))is=is+1 
          if(list(k,10,ic1).eq.list(k-1,10,ic1))is=is+1   
          if(list(k,11,ic1).eq.list(k-1,11,ic1))is=is+1   
          if(list(k,13,ic1).eq.list(k-1,13,ic1))is=is+1    
          if(list(k,14,ic1).eq.list(k-1,14,ic1))is=is+1       
          
        endif

c        if(icc.le.ncc)then
c         if(list(k, 3,ic1).eq.35.or.   
c    .       list(k, 8,ic1).eq.35.or.    
c    .       list(k,11,ic1).eq.35.or.  
c    .       list(k,14,ic1).eq.35)is1=is1+1 
c        endif

c       if(list(k,1,ic1).le.5.and.list(k,18,ic1).ge.2)is1=1!inofeyn=1
        
        if(is.ne.8.and.is1.ne.1) !8)       
     .  ipp(list(k,2,ic1),list(k,3,ic1),2)=
     .  ipp(list(k,2,ic1),list(k,3,ic1),2)+1
        if(ipp(list(k,2,ic1),list(k,3,ic1),1).eq.0)then
        ip=ip+1
        ipp(list(k,2,ic1),list(k,3,ic1),1)=ip
        endif
        if(ipp(list(k,2,ic1),list(k,3,ic1),1).ne.0)then
         if(is.ne.8.and.is1.ne.1)then !8)then
          ipp(list(k,2,ic1),list(k,3,ic1),3)=
     .    ipp(list(k,2,ic1),list(k,3,ic1),3)+1
          list(k,5,ic1)=ipp(list(k,2,ic1),list(k,3,ic1),3)
cprint*,k,ic1,list(k,2,ic1),list(k,3,ic1),list(k,5,ic1)
         endif
        endif
        
        ii1=list(k,2,ic1)
        mm1=list(k,3,ic1)
       
        enddo
        
        ii1=0
        mm1=0
        
        do k=1,k1
        
        list(k,4,ic1)=ipp(list(k,2,ic1),list(k,3,ic1),1)
        list(k,6,ic1)=ipp(list(k,2,ic1),list(k,3,ic1),2)
        list(k,9,ic1)=ipp(list(k,7,ic1),list(k,8,ic1),1)
        list(k,12,ic1)=ipp(list(k,10,ic1),list(k,11,ic1),1)
        list(k,15,ic1)=ipp(list(k,13,ic1),list(k,14,ic1),1)
        if(list(k,6,ic1).gt.maxmul)maxmul=list(k,6,ic1)
        
        enddo
        
        write(nunit1,'(a7,2i6,a24,i8,a15)')
     . 'for the',icc-1,ic1,
     . '  colour conf. there are',k1,'  subamplitudes'
        
        if(k1.gt.kmax)kmax=k1
        if(list(k1,4,ic1).gt.imax)imax=list(k1,4,ic1)
        
        write(nunit1,'(19i4)')(k,list(k,1:18,ic1),k=1,k1)
        
        write(nunit1,*)'the number of Feynman graphs = '
     .  ,ife(2**n-2,an(ifl(1)))
        write(nunit1,*)
     .  'the number of Feynman graphs = ',ife(2**n-2,an(ifl(1)))
        
        

        if(k1.le.ngues.and.inofeyn.eq.0)then
        allocate(ico(k1,18),stat=istat)
        ico(1:k1,1:18)=list(1:k1,1:18,ic1)
        call feyn(n,k1,maxmul,ico)
        deallocate(ico)
        endif

        return
        
* -----------------------------------------------------------------------------       
        entry setlist(newncc)

        ncc=newncc
        deallocate(ih,ih1,icole,ipp,jxx,ife)
        allocate(list_tmp(kmax,18,ncc),stat=istat)
        list_tmp(1:kmax,1:18,1:ncc)=list(1:kmax,1:18,1:ncc)
        deallocate(list)
        
        allocate(list(kmax,18,ncc),stat=istat)
        list(1:kmax,1:18,1:ncc)=list_tmp(1:kmax,1:18,1:ncc)
        deallocate(list_tmp)
        if(repeat.eq.1)then
        write(21,*)kmax,ncc,imax
        write(21,*)list1
        write(21,*)list
        write(21,*)kcou
        endif
        allocate(zy(imax,8),stat=istat)
  
        return
* -----------------------------------------------------------------------------       
        entry getlist

        read(21,*)kmax,ncc,imax
        print*,'kmax,ncc,imax',kmax,ncc,imax
        allocate(list(kmax,18,ncc),list1(n,3),kcou(ncc),stat=istat)
        read(21,*)list1
        read(21,*)list
        read(21,*)kcou
        allocate(zy(imax,8),stat=istat)
  
        return
* -----------------------------------------------------------------------------       
       entry iniqq

c       zi=dcmplx(dnou(0),dnou(1))
c       pi=dacos(-dnou(1))

c corrected on 6.7.2006 (Worek) in order to get correct results for repeat=2
      data init_pi/0/
      if(init_pi.eq.0)then
       call mypi(pi)
       zi=dcmplx(0,1)
       init_pi=1
      endif

        do k=1,n
        
        do j=1,5
        zq1(j)=zq(k,j)
        enddo
        z1(1:4)=0
        z2(1:4)=0
        z3(1:4)=0
        
        goto(41,42,43,44,45,46,47)list1(k,3)
        
 41      continue

         zq1(2)=dcmplx(dreal(zq1(2))*io(k),dimag(zq1(2)))
         zq1(1)=zq1(1)*io(k)
         zq1(3)=zq1(3)*io(k)
         zq1(4)=zq1(4)*io(k)


        if(iranhel.eq.0)then
        if(ipol(k).eq.1)call eminus(z0,zq1)
        if(ipol(k).eq.2)call  eplus(z0,zq1)
        else
        r=rnmy(0)*2*pi
        call eminus(z1,zq1)
        call eplus(z2,zq1)
        z0(1:4)=(dcos(r)+zi*dsin(r))*z1(1:4)
     &         +(dcos(r)-zi*dsin(r))*z2(1:4)
        endif
        
        goto50
 42      continue
 
        zq1(2)=dcmplx(dreal(zq1(2))*io(k),dimag(zq1(2)))
        zq1(1)=zq1(1)*io(k)
        zq1(3)=zq1(3)*io(k)
        zq1(4)=zq1(4)*io(k)

       
        if(iranhel.eq.0)then
        if(ipol(k).eq.1)call eminus(z0,zq1)
        if(ipol(k).eq.2)call  eplus(z0,zq1)
        if(ipol(k).eq.3)call  elong(z0,zq1)
        else
        r=rnmy(0)*2*pi
        call eminus(z1,zq1)
        call eplus(z2,zq1)
        call  elong(z3,zq1)
        z0(1:4)=(dcos(r)+zi*dsin(r))*z1(1:4)
     &         +(dcos(r)-zi*dsin(r))*z2(1:4)
     &         +z3(1:4)
        endif
        
        goto50
 43      continue
        
        if(iranhel.eq.0)then
        if(ipol(k).eq.2)call uplus(z0,zq1) !ru(z0,zq1)
        if(ipol(k).eq.1)call uminus(z0,zq1)!lu(z0,zq1)
c        print*,'z0 === >>',z0(1:4)
        else
        r=rnmy(0)*2*pi
        call uplus(z1,zq1)
        call uminus(z2,zq1)
        z0(1:4)=(dcos(r)+zi*dsin(r))*z1(1:4)
     &         +(dcos(r)-zi*dsin(r))*z2(1:4)
        endif
        
        goto50
 44      continue
 
        if(iranhel.eq.0)then
        if(ipol(k).eq.2)call ubplus(z0,zq1) !rub(z0,zq1)
        if(ipol(k).eq.1)call ubminus(z0,zq1)!lub(z0,zq1)
c        print*,'z0 === >>',z0(1:4)
        else
        r=rnmy(0)*2*pi
        call ubplus(z1,zq1)
        call ubminus(z2,zq1)
        z0(1:4)=(dcos(r)+zi*dsin(r))*z1(1:4)
     &         +(dcos(r)-zi*dsin(r))*z2(1:4)
        endif
        
        goto50
 45      continue
 
        if(iranhel.eq.0)then
        if(ipol(k).eq.2)call vbplus(z0,zq1) !lub(z0,zq1)
        if(ipol(k).eq.1)call vbminus(z0,zq1)!rub(z0,zq1)
c        print*,'z0 === >>',z0(1:4)
        else
        r=rnmy(0)*2*pi
        call vbplus(z1,zq1)
        call vbminus(z2,zq1)
        z0(1:4)=(dcos(r)+zi*dsin(r))*z1(1:4)
     &         +(dcos(r)-zi*dsin(r))*z2(1:4)
        endif
        
        goto50
 46      continue
 
        if(iranhel.eq.0)then
        if(ipol(k).eq.2)call vplus(z0,zq1) !lu(z0,zq1)
        if(ipol(k).eq.1)call vminus(z0,zq1)!ru(z0,zq1)
c        print*,'z0 === >>',z0(1:4)
        else
        r=rnmy(0)*2*pi
        call vplus(z1,zq1)
        call vminus(z2,zq1)
        z0(1:4)=(dcos(r)+zi*dsin(r))*z1(1:4)
     &         +(dcos(r)-zi*dsin(r))*z2(1:4)
        endif
        
        goto50
 47      continue
         z0(1)=dcmplx(dnou(1),dnou(0))
         z0(2)=dcmplx(dnou(0),dnou(0))
         z0(3)=dcmplx(dnou(0),dnou(0))
         z0(4)=dcmplx(dnou(0),dnou(0))
        
        goto50
        
 50     continue
 
        zy(k,1)=z0(1)
        zy(k,2)=z0(2)
        zy(k,3)=z0(3)
        zy(k,4)=z0(4)

        zy(k,5)=dcmplx(dreal(zq(k,1)),dnou(0))*io(k)
        zy(k,6)=dcmplx(dreal(zq(k,2)),dnou(0))*io(k)
        zy(k,7)=zq(k,3)*io(k)
        zy(k,8)=zq(k,4)*io(k)


! GAUGE INVARIANCE CHECK
       if(k.eq.n+1)then
        zy(k,1:4)=zy(k,5:8)!/(zy(k,5)+zy(k,6))/2
       endif
        enddo

        return
* -----------------------------------------------------------------------------       
        entry nextq(kc)
        
        
 	do i=n+1,imax
 	 do k=1,8
 	  zy(i,k)=dcmplx(dnou(0),dnou(0))
 	 enddo
  	enddo
        
        
        if(kcou(kc).lt.1)return

        do k=1,kcou(kc)
       
        
        ir=list(k,1,kc)
        ii=list(k,2,kc)
c moje 
        ii1=list(k,7,kc)
        ii2=list(k,10,kc)
        ii3=list(k,13,kc)
c moje
        mm=list(k,3,kc)
        m1=list(k,8,kc)
        m2=list(k,11,kc)
        m3=list(k,14,kc)
        l= list(k,16,kc)
        isgn=list(k,17,kc)
        igluon=list(k,18,kc)
        
        j0=list(k,4,kc)
        j1=list(k,9,kc)
        j2=list(k,12,kc)
        j3=0
        if(list(k,13,kc).ne.0)j3=list(k,15,kc)
         
         
        
        do j=1,4
         z0(j)=0
         z1(j)=zy(j1,j)
         z2(j)=zy(j2,j)
         zp0(j)=zy(j1,j+4)+zy(j2,j+4)
         if(list(k,13,kc).ne.0)then
           z3(j)=zy(j3,j)
          zp0(j)=zp0(j)+zy(j3,j+4)
         endif
         zy(j0,j+4)=zp0(j)
        enddo



c       print*,
c    .'ir, ii, j0, j1, j2, j3, mm, m1, m2, m3,kmax,imax, kc,kcou(kc),k'
c       print'(15i4)', 
c    .  ir,ii,j0,j1,j2,j3,mm,m1,m2,m3,kmax,imax,kc,kcou(kc),k
c       write(nunit1,'(19i4)')list(k,1:18,kc)

        goto(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)ir
        
 4      continue
        
c       if(ii.eq.10.or.ii.eq.6)then
c        z0(1:4)=0
c        goto99      
c       endif
        
        do j=1,4
        zp1(j)=zy(j1,j+4)
        zp2(j)=zy(j2,j+4)
        enddo
        


         zg=zgv3(mm,m1,m2)
        if(igluon.eq.2)zg=-zg
        call xv3(z0,zp0,z1,zp1,z2,zp2,mm,zg,isgn)
c       print*,'z0,zp0,z1,zp1,z2,zp2,mm,zg,isgn',
c    .          z0,zp0,z1,zp1,z2,zp2,mm,zg,isgn  
c        print*,''
c        print*,'xv3'
c        print*,'z1',z1(1:4)
c        print*,'z2',z2(1:4)
c        print*,'z0',z0(1:4)

c       if(level(n,list(k,7,kc)).eq.1)
c    .   z0(1:4)=z0(1:4)
c    .          /dsqrt(dnou(3))*dcmplx(dnou(0),dnou(1))
c       if(level(n,list(k,10,kc)).eq.1)
c    .   z0(1:4)=z0(1:4)
c    .          /dsqrt(dnou(3))*dcmplx(dnou(0),dnou(1))
         
        goto99


 5      continue
        
        
        zg=zgv4(mm,m1,m2,m3)
        
        if(igluon.le.2)call xv4(z0,zp0,z1,z2,z3,mm,zg,isgn)
        if(igluon.eq.3)call xv4(z0,zp0,z2,z3,z1,mm,zg,isgn)
        if(igluon.eq.4)call xv4(z0,zp0,z3,z1,z2,mm,zg,isgn)
        

        goto99

 1      continue

c        print*,''
c        print*,'====== xvff =====',l
c        print*,'m1,m2,m0',m1,m2,mm
        do j=1,4
        zp1(j)=zy(j1,j+4)
        zp2(j)=zy(j2,j+4)
        enddo
c        print*,'zp1',zp1(1:4)
c        print*,'zp2',zp2(1:4)
       
        zgl=zgvffl(mm,m1,m2)
        zgr=zgvffr(mm,m1,m2) 
        call xvff(z0,zp0,z1,z2,mm,zgl,zgr,isgn)

c        print*,'zp0',zp0(1:4)
c        print*,'z1',z1(1:4)
c        print*,'z2',z2(1:4)
c        print*,'z0 == przed ==',z0(1:4)
       
c       if(igluon.eq.2)then
c        z0(1:4)=z0(1:4)/dsqrt(dnou(3))*dcmplx(dnou(0),dnou(1))
c        if(level(n,ii).eq.n-1)
c    .   z0(1:4)=z0(1:4)
c    .          /dsqrt(dnou(3))*dcmplx(dnou(0),dnou(1))
c       endif
        
        if(igluon.eq.2)then
        do i=1,4
        z0(i)=z0(i)/dsqrt(dnou(3))*dcmplx(dnou(0),dnou(1))
        enddo
        endif 
        if(igluon.eq.3)then
        do i=1,4
        z0(i)=-z0(i)/dnou(3)
        enddo
        endif
c         print*,'z0 ====',z0(1:4)
c       if(ii.eq.28)print*,'-------',ii,mm,igluon,l,
c    .  z0(4)

c        do kk=1,4
c           print*,'z1(',kk,')',z1(kk)
c        enddo
c        do kk=1,4
c           print*,'z2(',kk,')',z2(kk)
c        enddo
c        do kk=1,4
c           print*,'z0(',kk,')',z0(kk)
c        enddo

        goto99

 3      continue
        

        if(ii.ne.2**n-2)then
        
        if(l.eq.2)then
        zgr=zgvffr(an(m1),-mm,m2)
        call xffvr(z0,zp0,z1,z2,mm,zgr,isgn,parmas(mm))
c    .                                  -zi*parwid(mm)/2)
        elseif(l.eq.1)then
        zgl=zgvffl(an(m1),-mm,m2)
        call xffvl(z0,zp0,z1,z2,mm,zgl,isgn,parmas(mm))
c    .                                  -zi*parwid(mm)/2)

        endif
        else   
        
        if(l.eq.1)then
        zgl=zgvffl(an(m1),-mm,m2)
        call xffvl0(z0,z1,z2,zgl,isgn)
        elseif(l.eq.2)then
        zgr=zgvffr(an(m1),-mm,m2)
        call xffvr0(z0,z1,z2,zgr,isgn)
        endif
          
        endif
        
c       if(igluon.eq.2)then
c        z0(1:4)=z0(1:4)/dsqrt(dnou(3))*dcmplx(dnou(0),dnou(1))
c        if(level(n,list(k,7,kc)).eq.1)
c    .   z0(1:4)=z0(1:4)
c    .          /dsqrt(dnou(3))*dcmplx(dnou(0),dnou(1))
c       endif

        if(igluon.eq.2)then
        do i=1,4
        z0(i)=z0(i)/dsqrt(dnou(3))*dcmplx(dnou(0),dnou(1))
        enddo
        endif
        if(igluon.eq.3)then
        do i=1,4
        z0(i)=-z0(i)/dnou(3)
        enddo
        endif
        
        goto99

 2      continue

c        print*,''
c        print*,'====== xaffv =====',l
c        print*,'m1,m2,m0',m1,m2,mm
         
        do j=1,4
        zp1(j)=zy(j1,j+4)
        zp2(j)=zy(j2,j+4)
        enddo
c        print*,'zp1',zp1(1:4)
c        print*,'zp2',zp2(1:4)

         if(ii.ne.2**n-2)then

         if(l.eq.2)then
         zgr=zgvffr(an(m1),m2,-mm)
         call xaffvr(z0,zp0,z1,z2,mm,zgr,isgn,parmas(mm))
c    .                                    -zi*parwid(mm)/2)

c         print*,'xaffvr =============== >>>>>>>>>'
c         print*,'z1',z1(1:4)
c         print*,'z2',z2(1:4)
         elseif(l.eq.1)then
         zgl=zgvffl(an(m1),m2,-mm)
         call xaffvl(z0,zp0,z1,z2,mm,zgl,isgn,parmas(mm))
c    .                                    -zi*parwid(mm)/2)

c         print*,'xaffvl =============== >>>>>>>>>'
c         print*,'z1',z1(1:4)
c         print*,'z2',z2(1:4)

         endif
             
         elseif(ii.eq.2**n-2)then

         if(l.eq.2)then
         zgr=zgvffr(an(m1),m2,-mm)
         call xaffvr0(z0,z1,z2,zgr,isgn)
c         print*,'xaffvr0 =============== >>>>>>>>>'
c         print*,'z1',z1(1:4)
c         print*,'z2',z2(1:4)
         elseif(l.eq.1)then
         zgl=zgvffl(an(m1),m2,-mm)
         call xaffvl0(z0,z1,z2,zgl,isgn)
c         print*,'xaffvl0  =============== >>>>>>>>>'
c         print*,'z1',z1(1:4)
c         print*,'z2',z2(1:4)
         endif
  
         endif

c       if(igluon.eq.2)then
c        z0(1:4)=z0(1:4)/dsqrt(dnou(3))*dcmplx(dnou(0),dnou(1))
c        if(level(n,list(k,7,kc)).eq.1)
c    .   z0(1:4)=z0(1:4)
c    .          /dsqrt(dnou(3))*dcmplx(dnou(0),dnou(1))
c       endif
 
        if(igluon.eq.2)then
        do i=1,4
        z0(i)=z0(i)/dsqrt(dnou(3))*dcmplx(dnou(0),dnou(1))
        enddo
        endif
        if(igluon.eq.3)then
        do i=1,4
        z0(i)=-z0(i)/dnou(3)
        enddo
        endif

c        do kk=1,4
c           print*,'z1(',kk,')',z1(kk)
c        enddo
c        do kk=1,4
c           print*,'z2(',kk,')',z2(kk)
c        enddo
c        do kk=1,4
c           print*,'z0(',kk,')',z0(kk)
c        enddo


c        print*,'z0',z0(1:4)

c       if(igluon.eq.2)
c    .  z0(1:4)=z0(1:4)/dsqrt(dnou(3))*dcmplx(dnou(0),dnou(1))
c       if(igluon.eq.3)
c    .  z0(1:4)=-z0(1:4)/dnou(3)


c       if(ii.eq.30)print*,'-------',ii,mm,igluon,l,
c    .  z0(4)

        goto99

 6      continue

c        print*,''
c        print*,'ffs' 
c        print*,'m1,m2,mm ===>',m1,m2,mm
c        print*,'i1,i2,i0 ===>',ii1,ii2,ii,' ===>'
        if(ii.ne.2**n-2)then
        
        if(l.eq.2)then
        zgr=zgsffr(an(m1),-mm,m2)
        call xffsr(z0,zp0,z1(1),z2,mm,zgr,isgn,parmas(mm))
c    .                                     -zi*parwid(mm)/2)
c        print*,'ffsr'
c        print*,'z0',z0(1:4)
        elseif(l.eq.1)then
        zgl=zgsffl(an(m1),-mm,m2)
        call xffsl(z0,zp0,z1(1),z2,mm,zgl,isgn,parmas(mm))
c     .                                     -zi*parwid(mm)/2)
c        print*,'ffsl'
c        print*,'z0',z0(1:4)
        endif
       
        else   

        if(l.eq.1)then
        zgl=zgsffl(an(m1),-mm,m2)
        call xffsl0(z0,z1(1),z2,zgl,isgn)
c        print*,'ffsl0'
c        print*,'z0',z0(1:4)
        elseif(l.eq.2)then
        zgr=zgsffr(an(m1),-mm,m2)
        call xffsr0(z0,z1(1),z2,zgr,isgn)
c        print*,'ffsr0'
c        print*,'z0',z0(1:4)
        endif
          
        endif
         
        goto99
 
 7      continue

         if(ii.ne.2**n-2)then
         
         if(l.eq.1)then
         zgl=zgsffl(an(m1),m2,-mm)
         call xaffsl(z0,zp0,z1(1),z2,mm,zgl,isgn,parmas(mm))
c    .                                       -zi*parwid(mm)/2)
         elseif(l.eq.2)then
         zgr=zgsffr(an(m1),m2,-mm)
         call xaffsr(z0,zp0,z1(1),z2,mm,zgr,isgn,parmas(mm))
c    .                                       -zi*parwid(mm)/2)
         endif
             
         else
       
         if(l.eq.2)then
         zgr=zgsffr(an(m1),m2,-mm)
         call xaffsr0(z0,z1(1),z2,zgr,isgn)
         elseif(l.eq.1)then
         zgl=zgsffl(an(m1),m2,-mm)
         call xaffsl0(z0,z1(1),z2,zgl,isgn)
         endif
  
         endif


        goto99

 8      continue
        
        zgl=zgsffl(mm,m1,m2)
        zgr=zgsffr(mm,m1,m2) 
        call xsff(z0(1),zp0,z1,z2,mm,zgl,zgr,isgn)
     
        goto99

 9      continue
        
        zg=zgvvs(mm,m1,m2)
c        print*,''
c        print*,'vvs' 
c        print*,'m1,m2,mm ===>',m1,m2,mm
c        print*,'i1,i2,i0 ===>',ii1,ii2,ii,' ===>'
c        print*,'zgvvs(mm,m1,m2)',zgvvs(mm,m1,m2)
        call xvvs(z0,zp0,z1,z2(1),mm,zg,isgn)
c        print*,'z0',z0(1:4)
        goto99
 
 10     continue
        
        zg=zgsvv(mm,m1,m2)
        call xsvv(z0(1),zp0,z1,z2,mm,zg,isgn)
     
        goto99
 
 11     continue
        
        zg=zgvvss(mm,m1,m2,m3)
c        print*,''
c        print*,'vvss' 
c        print*,'m1,m2,m3,mm ===>',m1,m2,m3,mm
c        print*,'i1,i2,i3,i0 ===>',ii1,ii2,ii3,ii,' ===>'
c        print*,'zgvvss(mm,m1,m2,m3)',zgvvss(mm,m1,m2,m3)
        call xvvss(z0,zp0,z1,z2(1),z3(1),mm,zg,isgn)
c        print*,'z0',z0(1:4)
        goto99

 12     continue
        
        zg=zgssvv(mm,m1,m2,m3)
c        print*,''
c        print*,'ssvv' 
c        print*,'m1,m2,m3,mm ===>',m1,m2,m3,mm
c        print*,'i1,i2,i3,i0 ===>',ii1,ii2,ii3,ii,' ===>'
c        print*,'zgssvv(mm,m1,m2,m3)',zgssvv(mm,m1,m2,m3)
        call xssvv(z0(1),zp0,z1(1),z2,z3,mm,zg,isgn)
c        print*,'z0',z0(1)
        goto99
 
 13     continue
        
        zg=zgs3(mm,m1,m2)
c        print*,''
c        print*,'s3' 
c        print*,'m1,m2,mm ===>',m1,m2,mm
c        print*,'i1,i2,i0 ===>',ii1,ii2,ii,' ===>'
c        print*,'zgs3(mm,m1,m2)',zgs3(mm,m1,m2)
        call xs3(z0(1),zp0,z1(1),z2(1),mm,zg,isgn)

c        print*,'z0',z0(1)
     
        goto99
 
 14     continue
        
        zg=zgs4(mm,m1,m2,m3)
c        print*,''
c        print*,'s4' 
c        print*,'m1,m2,m3,mm ===>',m1,m2,m3,mm
c        print*,'i1,i2,i3,i0 ===>',ii1,ii2,ii3,ii,' ===>'
c        print*,'zgs4(mm,m1,m2,m3)',zgs4(mm,m1,m2,m3)
        call xs4(z0(1),zp0,z1(1),z2(1),z3(1),mm,zg,isgn)
c        print*,'z0',z0(1)
        goto99
 
 15     continue
        
        do j=1,4
        zp1(j)=zy(j1,j+4)
        enddo
        
        zg=zgssv(mm,m1,m2)
        call xssv(z0(1),zp0,z1(1),zp1,z2,mm,zg,isgn)
     
        goto99
 
 16     continue
      
        do j=1,4
        zp1(j)=zy(j1,j+4)
        zp2(j)=zy(j2,j+4)
        enddo
        
        zg=zgvss(mm,m1,m2)
        call xvss(z0,zp0,z1(1),zp1,z2(1),zp2,mm,zg,isgn)
     
        goto99
 
 99     continue

c       if(list(k,3,kc).eq.35)then
c        if(ii.ne.2**n-2)then
c         call propag(z0,mm,zp0)
c        endif
c       endif

        do j=1,4
        zy(j0,j)=zy(j0,j)+z0(j)
        enddo


c       print*,k,kc,list(k,1:18,kc)

c       if((list(k,5,kc).eq.list(k,6,kc).
c    .  or.list(k,5,kc).eq.0).and.
c    .  list(k,4,kc).ne.list(k+1,4,kc).and.
c    .  k.le.kcou(kc))then
        log1=(list(k,5,kc).eq.list(k,6,kc).or.list(k,5,kc).eq.0)
        log2=list(k,4,kc).ne.list(k+1,4,kc)
        log3=k.le.kcou(kc)
        if(log1.and.log2.and.log3)then
c       log4=.not.(list(k,3,kc).eq.35)
c       if(log1.and.log2.and.log3.and.log4)then
  
        do j=1,4
        z0(j)=zy(j0,j)
        enddo
c        print*,'z0 total',z0(1)
c        print*,''

        if(ii.ne.2**n-2)then
c              print*,'=========================>'
c              print*,'mm,ii ==== prop ==========>  ',mm,ii
c              print*,'=========================>'
c              print*,''
        call propag(z0,mm,zp0)
        endif

        do j=1,4
        zy(j0,j)=z0(j)
        enddo 

        endif
        
        enddo
    
        
        return
       
        entry ampq(k2,zamp)
        
        
        zamp=dcmplx(dnou(0),dnou(0))
c        print*,'kcou(k2)',kcou(k2)
        if(kcou(k2).lt.1)return
        
        if(ifl(1).lt.30)then
! for fermions
        do i=1,4
        zamp=zamp+zy(list(kcou(k2),4,k2),i)*zy(1,i)
c        print*,'zamp ======= >>>>>>>',zamp
        enddo

        elseif(ifl(1).ge.31.and.ifl(1).le.40)then
! for v-bosons
        zamp=zprod(zy(list(kcou(k2),4,k2),1:4),zy(1,1:4))
c        print*,'zamp ======= >>>>>>>',zamp
        elseif(ifl(1).ge.41)then
! for scalars
        zamp=zy(list(kcou(k2),4,k2),1)*zy(1,1)
        endif
c        print*,'zamp ======= >>>>>>>',zamp
      
        return
       
        end


        
