       include 'declare.h'
       
       integer n,io(20),ifl(20)
c      include 'common_masses.h'
c      include 'common_flags.h'
c      include 'common_feyn.h'
c      include 'common_new.h'
c      include 'common_print.h'
c      include 'common_phegas_mom.h'
       dimension pmom(20,5)


       character*24, histo,error
 
       character*2 char(20)
       character*100 process

       nunit1=6

c	reads and then prints variables from the input file.
c       print*,'histo file'
       read*,histo,error
       print*,'histo file: ',histo,'error file: ', error
c       print*,'repeat,ranhel'
       read*,repeat,iranhel
       print*,'repeat: ',repeat,'  ranhel: ',iranhel
c       print*,'Number of particles'
       read*,n
       print*,'Number of particles ', n
       print*,'Flavour of particles'
c	reads the flavours of the n first particles as shown in the input file and then prints them out
       read*,(ifl(i),i=1,n)
       print*,(ifl(i),i=1,n)
       print*,'iflag,iunitary,ihiggs,iwidth'
       read*,iflag,iunitary,ihiggs,iwidth
       print*,iflag,'     ',iunitary,'      ',ihiggs,'     ',iwidth


c	defines the particles (explanation of the HELAC particle codes)
       do i=1,n
        if(ifl(i).eq. 2)char(i)='E-'
        if(ifl(i).eq.-2)char(i)='E+'
        if(ifl(i).eq. 1)char(i)='Ne'
        if(ifl(i).eq.-1)char(i)='N1'
        if(ifl(i).eq. 3)char(i)='Uq'
        if(ifl(i).eq.-3)char(i)='Ua'
        if(ifl(i).eq. 4)char(i)='Dq'
        if(ifl(i).eq.-4)char(i)='Da'
        if(ifl(i).eq. 6)char(i)='M-'
        if(ifl(i).eq.-6)char(i)='M+'
        if(ifl(i).eq. 5)char(i)='Nm'
        if(ifl(i).eq.-5)char(i)='N2'
        if(ifl(i).eq. 7)char(i)='Cq'
        if(ifl(i).eq.-7)char(i)='Ca'
        if(ifl(i).eq. 8)char(i)='Sq'
        if(ifl(i).eq.-8)char(i)='Sa'
        if(ifl(i).eq. 10)char(i)='T-'
        if(ifl(i).eq.-10)char(i)='T+'
        if(ifl(i).eq. 9)char(i)='Nt'
        if(ifl(i).eq.-9)char(i)='N3'
        if(ifl(i).eq. 11)char(i)='Tq'
        if(ifl(i).eq.-11)char(i)='Ta'
        if(ifl(i).eq. 12)char(i)='Bq'
        if(ifl(i).eq.-12)char(i)='Ba'
        if(ifl(i).eq.31)char(i)='A0'
        if(ifl(i).eq.32)char(i)='Z0'
        if(ifl(i).eq.33)char(i)='W+'
        if(ifl(i).eq.34)char(i)='W-'
        if(ifl(i).eq.35)char(i)='G0'
       enddo

c	prints out the process under study
       write(process,*)(char(i),i=1,n)
       print*,process(2:2*n+1)

c      open(6,  file='out_'//process(2:2*n+1)//'.out')
c      nunit1=6
c      open(nunit1,file='proc_'//process(2:2*n+1)//'.out')

c	opens files in which the results will be stored 
c      nunit2=32
c      open(nunit2,file='kine_'//process(2:2*n+1)//'.out')
       nunit3=30
       open(nunit3,file='even_'//process(2:2*n+1)//'.out'
     . ,form='unformatted')
       nunit4=31
       open(nunit4,file='sample'//process(2:2*n+1)//'.evt')

       istop=1
       k=0
       do while(istop.eq.1)
       k=k+1
       READ(30,end=100) NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
       WRITE(31,5200) NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
       do i=1,NUP
       READ(30) IDUP,ISTUP,
     & iMOTHUP1,iMOTHUP2,ICOLUP1,ICOLUP2,
     & px,py,pz,p0,pm0,VTIMUP,SPINUP
c      read(30,end=100)(pmom(ii,1:4),ii=1,n)
       write(31,5300) IDUP,ISTUP,
     & iMOTHUP1,iMOTHUP2,ICOLUP1,ICOLUP2,
     & px,py,pz,p0,pm0,VTIMUP,SPINUP
c      print*,k,pmom(3,1:4)
       enddo
       enddo

 100  CONTINUE

 5200 FORMAT(1P,2I6,4E14.6)
 5300 FORMAT(1P,I8,5I5,5E18.10,E14.6,E12.4)

       end
      

