       subroutine geti(i,j,w)
       include 'declare.h'
       include 'mc.h'
       common/bookings/f0(nx),f1(nx),f2(nx),f3(nx),f4(nx)
        if(j.eq.0)w=f0(i)
        if(j.eq.1)w=f1(i)
        if(j.eq.2)w=f2(i)
        if(j.eq.3)w=f3(i)
        if(j.eq.4)w=f4(i)
       return
       end

       subroutine clear(i)
       include 'declare.h'
       include 'mc.h'
       common/bookings/f0(nx),f1(nx),f2(nx),f3(nx),f4(nx)
        f0(i)=0
        f1(i)=0
        f2(i)=0
        f3(i)=0
        f4(i)=0
       return
       end
       
       subroutine bookin(i,w)
       include 'declare.h'
       include 'mc.h'
       common/bookings/f0(nx),f1(nx),f2(nx),f3(nx),f4(nx)
       data init/0/
       if(init.eq.0)then
        init=1
        f0(1:nx)=0
        f1(1:nx)=0
        f2(1:nx)=0
        f3(1:nx)=0
        f4(1:nx)=0
       endif
       f0(i)=f0(i)+1
       f1(i)=f1(i)+w
       f2(i)=f2(i)+w*w
       f3(i)=f3(i)+w*w*w
       f4(i)=f4(i)+w*w*w*w
       return
       end
       
c      subroutine errest(s0,s1,s2,s3,s4,xest,yest,iwr)
       subroutine errest(i,xest,yest,iwr)
       include 'declare.h'
       real(kind(1d0)) zest
       include 'mc.h'
       common/bookings/f0(nx),f1(nx),f2(nx),f3(nx),f4(nx)
       data nout/6/
        s0=f0(i)
        s1=f1(i)
        s2=f2(i)
        s3=f3(i)
        s4=f4(i)
        
        rn1=s0
        rn2=rn1*(s0-1)
        rn3=rn2*(s0-2)
        rn4=rn3*(s0-3)
        v1=s1
        v2=s2
        v3=s1**2-v2
        v4=s3
        v5=s2*s1-v4
        v6=s1**3-v4-3*v5
        v7=s4
        v8=s3*s1-v7
        v9=s2**2-v7
        v10=s2*s1**2-v7-2*v8-v9
        v11=s1**4-v7-4*v8-3*v9-6*v10
        xest=v1/rn1
        if(iwr.eq.1)write (nout,3) xest
    3   format('  estimator x: ',d15.6)
        if(rn2.gt.0) then
          yest=(v2/rn1-v3/rn2)/rn1
          if(iwr.eq.1)write (nout,4) yest
    4     format('  estimator y: ',d15.6)
          if(yest.lt.0) then
            if(iwr.eq.1)write (nout,5) yest
    5       format('  warning: variance estimator =',d15.6/,
     .             '  sign flipped in order to survive')
            yest=dabs(yest)
          endif
        else
          if(iwr.eq.1)write (nout,6) rn1
    6     format('  variance estimate not possible, n=',f4.1/,
     .           '  estimator put to zero in order to survive')
 
          yest=0
        endif
        if(rn4.gt.0) then
          zest=(    (rn2+    rn3)*v7/ rn1
     .         -4*(rn2+    rn3)*v8/ rn2
     .             +(rn2-    rn3)*v9/ rn2
     .         +4*(rn2+2d0*rn3)*v10/rn3
     .         -2*(rn2+2d0*rn3)*v11/rn4
     .         )/(rn1**2*rn2**2)
          if(iwr.eq.1)write (nout,7) zest
    7     format('  estimator z: ',d15.6)
          if(zest.lt.0) then
            if(iwr.eq.1)write (nout,8) zest
    8       format('  warning: variance-variance estimator =',d15.6/,
     .             '  sign flipped in order to survive')
            zest=dabs(zest)
          endif
        else
          if(iwr.eq.1)write (nout,9) rn1
    9     format('  variance-variance estimate not possible, n=',f4.1/,
     .           '  estimator put to zero in order to survive')
          zest=0
        endif
        if(iwr.eq.1)write (nout,10) xest,dsqrt(yest),yest,dsqrt(zest)
   10   format(
     .    '  average estimate :',d15.6/,16x,'+\- ',d15.6/,
     .    '  variance estimate:',d15.6/,16x,'+\- ',d15.6)
        if(dsqrt(zest).ge.0.5*yest.and.yest.gt.0d0.and.iwr.eq.1) 
     .  write (nout,11)
   11   format('  be aware that the error estimate may be bad!')
C-----------------------------------------------------------
        return
        end
