      subroutine tohisto(w)
      include 'declare.h'
      
      include 'common_int.h'
      include 'common_phegas_mom.h'
      dimension p1(4),p2(4)
      
      pi=dacos(-dnou(1))       
       

      call  cmstolab

      energy_max=0
      energy_min=7000d0
      i_min=0
      i_max=0
      do i=3,n
         if(pmom(i,4).gt.energy_max) then 
            energy_max=pmom(i,4)
            i_max=i
         endif
         if(pmom(i,4).lt.energy_min) then 
            energy_min=pmom(i,4)
            i_min=i
         endif
      enddo
      
c-----------------------------------------------
c       invariant mass distributions of 2-jets
c -----------------------------------------------

      p1(1:4)=pmom(3,1:4)+pmom(4,1:4)
      w34=dsqrt(scalar_product(p1,p1))
      call histo1(1,15,0.d0,800.d0,w34,w)
      
      p1(1:4)=pmom(3,1:4)+pmom(5,1:4)
      w35=dsqrt(scalar_product(p1,p1))
      call histo1(1,15,0.d0,800.d0,w35,w)
      
      p1(1:4)=pmom(3,1:4)+pmom(6,1:4)
      w36=dsqrt(scalar_product(p1,p1))
      call histo1(1,15,0.d0,800.d0,w36,w)
      
      p1(1:4)=pmom(3,1:4)+pmom(7,1:4)
      w37=dsqrt(scalar_product(p1,p1))
      call histo1(1,15,0.d0,800.d0,w37,w)

c     p1(1:4)=pmom(3,1:4)+pmom(8,1:4)
c     w38=dsqrt(scalar_product(p1,p1))
c     call histo1(1,20,0.d0,800.d0,w38,w)

      p1(1:4)=pmom(4,1:4)+pmom(5,1:4)
      w45=dsqrt(scalar_product(p1,p1))
      call histo1(1,15,0.d0,800.d0,w45,w)
      
      p1(1:4)=pmom(4,1:4)+pmom(6,1:4)
      w46=dsqrt(scalar_product(p1,p1))
      call histo1(1,15,0.d0,800.d0,w46,w)

      p1(1:4)=pmom(4,1:4)+pmom(7,1:4)
      w47=dsqrt(scalar_product(p1,p1))
      call histo1(1,15,0.d0,800.d0,w47,w)

c     p1(1:4)=pmom(4,1:4)+pmom(8,1:4)
c     w48=dsqrt(scalar_product(p1,p1))
c     call histo1(1,20,0.d0,800.d0,w48,w)

      p1(1:4)=pmom(5,1:4)+pmom(6,1:4)
      w56=dsqrt(scalar_product(p1,p1))
      call histo1(1,15,0.d0,800.d0,w56,w)

      p1(1:4)=pmom(5,1:4)+pmom(7,1:4)
      w57=dsqrt(scalar_product(p1,p1))
      call histo1(1,15,0.d0,800.d0,w57,w)

c     p1(1:4)=pmom(5,1:4)+pmom(8,1:4)
c     w58=dsqrt(scalar_product(p1,p1))
c     call histo1(1,20,0.d0,800.d0,w58,w)

      p1(1:4)=pmom(6,1:4)+pmom(7,1:4)
      w67=dsqrt(scalar_product(p1,p1))
      call histo1(1,15,0.d0,800.d0,w67,w)

c     p1(1:4)=pmom(6,1:4)+pmom(8,1:4)
c     w68=dsqrt(scalar_product(p1,p1))
c     call histo1(1,20,0.d0,800.d0,w68,w)

c     p1(1:4)=pmom(7,1:4)+pmom(8,1:4)
c     w78=dsqrt(scalar_product(p1,p1))
c     call histo1(1,20,0.d0,800.d0,w78,w)


c ------------------------------------------------------
c       pt distributions for jet with E_max and E_min
c ------------------------------------------------------
      
      p1(1:4)=pmom(i_max,1:4)
      pt_max=transverse(p1)
      call histo1(2,15,0.d0,400.d0,pt_max,w)
      
      p1(1:4)=pmom(i_min,1:4)
      pt_min=transverse(p1)
      call histo1(3,15,0.d0,200.d0,pt_min,w)

c ----------------------------------------------------------------
c      pseudorapidity distributions for jet with E_max and E_min
c ----------------------------------------------------------------

      p1(1:4)=pmom(i_max,1:4)
      eta_max=rapidity(p1)
      call histo1(4,15,-3.5d0,3.5d0,eta_max,w)
        
      p1(1:4)=pmom(i_min,1:4)
      eta_min=rapidity(p1)
      call histo1(5,15,-3.5d0,3.5d0,eta_min,w)
        
      return
      end
      
      
